(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))) ?answer)

(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))

(deffacts init
           (troubleshoot-mode)
           (menu-level) 
           )
(defrule main-menu
                     (declare (salience 500))
                     (troubleshoot-mode) 
                     ?ml <- (menu-level)
                     =>
                     (retract ?ml) 
                     (printout t "                                   " crlf)
                     (printout t "  " crlf )
                     (printout t "       -      " crlf )
                     (printout t " .          - ,  " crlf )
                     (printout t " ,  ,  .            " crlf )
                     (printout t "    .  " crlf )
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1)    " crlf)
                     (printout t "                                2)   " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response))
                     )
(defrule tests
                     (problem-response 1) 
                     =>
                     (printout t "                                  "CHILDREN"!  " crlf )
                     (printout t "   " crlf )    
                     (printout t "        ,   ,  " crlf )
                     (printout t ",    ,        "CHILDREN".  " crlf )  
                     (printout t "   ,    ,     ,  " crlf )
                     (printout t "    (  ),   ,    " crlf )
                     (printout t "       .  " crlf )
                     (printout t " .  " crlf )
                     (printout t "   " crlf )
                     (if (yes-or-no-p "    (yes/no)? ")
                     then
                     (assert (da))
                     else
                     (assert (net))))

(defrule user-exit
                     (troubleshoot-mode)
                     (problem-response 2) 
                      =>
                     (printout t " !" crlf)
                     (halt))

(defrule konec
                     (net)
                     =>
                     (printout t " !" crlf)
                     (halt))

(defrule nachalo
                 (da)
                 =>
                    (printout t "   " crlf )
                    (if (yes-or-no-p "   (yes/no)? ")
                    then
                     (assert (duh))
                    else
                     (assert (neduh))))

(defrule duhanie
                (neduh)
                =>
                     (printout t " " crlf) 
                     (printout t "   ?" crlf)
                     (printout t "                   a)  " crlf)
                     (printout t "                   b)  ()  " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)))

(defrule duhanie2
                     (problem-response a) 
                     =>
                     (printout t " " crlf) 
                     (printout t "  :  " crlf )
                     (printout t "   " crlf )    
                     (printout t "      , ,      . " crlf )
                     (printout t "   ,      .     " crlf )  
                     (printout t ", , . ,      , ,    " crlf )
                     (printout t "     , , , ,      ,     " crlf )
                     (printout t ".         ,    .  " crlf )
                     (printout t "      , . " crlf )
                     (printout t "    : '   ', '   '  '     '. " crlf )
                     (printout t "          '     '.   " crlf )  
                     (printout t "     .    -  ,    " crlf )
                     (printout t "   .     ,     " crlf )
                     (printout t ".   .    ,      ,      " crlf )
                     (printout t ",   ,    .        " crlf )
                     (printout t ", .         .     " crlf )
                     (printout t "    -    ,      . " crlf )  
                     (printout t "     , , -     .     " crlf )
                     (printout t "      , ,       " crlf )
                     (printout t "   . ,    '   ',     " crlf )
                     (printout t " '   '.    ." crlf )
                     (printout t "   " crlf )    
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                    (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))                  

(defrule duhanie3
                     (problem-response b) 
                     =>
                     (printout t " " crlf) 
                     (printout t "  :  " crlf )
                     (printout t "   " crlf )    
                     (printout t "          .  " crlf )
                     (printout t ", ,          .    " crlf )  
                     (printout t "           90-100   .  " crlf )
                     (printout t " (  )   -   ,   8-9  -  , " crlf )
                     (printout t "    -  ,       .     " crlf )
                     (printout t "    ,         " crlf )
                     (printout t ":    - 15-18   ,      ..   " crlf )
                     (printout t "  .           " crlf )  
                     (printout t " .   ,     ,  ,  " crlf )
                     (printout t "  ,      .     ." crlf )
                     (printout t "   " crlf )    
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                    (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule nachalo2
              (duh)
               =>
                (printout t " " crlf) 
                (if (yes-or-no-p "  - ,  , ,    (yes/no)? ")
                then
                (assert (simptomu))
                else
                (assert (inorodnue tela)))) 

(defrule test
                (simptomu)
                 =>
                (printout t " " crlf) 
                (if (yes-or-no-p "     - , ,   (yes/no)? ")
                then
                (assert (simptoms))
                else
                (assert (simptoms2))))

(defrule rana
             (simptoms)
             =>
             (printout t "   " crlf )
             (printout t "  :" crlf)
             (printout t " " crlf)  
             (printout t "    , , .       " crlf)
             (printout t "    .     ." crlf))
                       
(defrule test1
               (simptoms2)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "    - ,    ,  
                            (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "   ." crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "     ,      " crlf)
                (printout t " .     ." crlf)
                else
                (assert (sotryasenie))))
                
(defrule sotryaseniemozga
                (sotryasenie)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "     :    ,   , 
                     ,  , ,   (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "   ." crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "   ,   ,     , " crlf)
                (printout t "   .    ." crlf)
                else
                (assert (vuvih))))

(defrule vuvihu
                (vuvih)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "        (),   , 
                                   (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t " . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "        .       , " crlf)
                (printout t "   .        , " crlf)
                (printout t "   ,   ,     . " crlf)
                (printout t "    ,      . " crlf)    
                else
                (assert (yshibposvonochnika)))) 

(defrule yshibposvonka
                (yshibposvonochnika)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "      ,     
                       ,     (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf)
                (printout t "     . " crlf) 
                (printout t "           . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "  :       ,   " crlf)
                (printout t "       . " crlf) 
                (printout t "  :     ,    ,   " crlf) 
                (printout t "      (, , )     ." crlf)
                else
                (assert (perelom)))) 

(defrule perelomu
                (perelom)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "       ,     
                      .   , ,      (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "   . " crlf)
                (printout t "           . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "  ,  ,   .   " crlf)
                (printout t "      ,    .   " crlf)
                (printout t "  ,    , ,   . .     " crlf)  
                (printout t " -       -    .     " crlf)
                (printout t "   - ,   .     . " crlf)  
                else
                (assert (perelom2))))

(defrule perelomu2
                (perelom2)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "       ,       (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t " . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "    .       .   " crlf)
                (printout t "    .     ." crlf)
                else
                (assert (perelom3))))

(defrule perelomu3
                (perelom3)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "       ,     
                      .   ,  (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t " . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "              " crlf)
                (printout t "   ,    ,    " crlf)
                (printout t "  .     . " crlf)  
                else
                (printout t "   " crlf )
                (printout t "      ,     ,  ,    " crlf )
                (printout t "        ,    ,   " crlf )
                (printout t "    .  . " crlf )
                (assert (proba))))                                                                                                               

(defrule test2
               (inorodnue tela)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "    :  ,  , ,
                         .       (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,          ." crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "      ,       ,  " crlf)
                (printout t " .           " crlf)
                (printout t " ." crlf)   
                else
                (assert (inorodnue tela2))))

(defrule test3
                (inorodnue tela2)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "    :    ,   , , ,
                    -  ,   , . 
                 ,  ,    (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,        .   -   " crlf)
                (printout t "     ( )." crlf)
                (printout t "" crlf)   
                (printout t "        :" crlf)
                (printout t " " crlf)  
                (printout t "          -  . " crlf)
                (printout t "      .       ()" crlf)
                (printout t "    ,      ." crlf)
                (printout t "      .   ,     " crlf) 
                (printout t " ." crlf)  
                (printout t "" crlf)   
                (printout t "      :" crlf)
                (printout t " " crlf)  
                (printout t "    .        , " crlf)
                (printout t "   -         .  " crlf)
                (printout t "  (    ).        10-15 ." crlf)
                else
                (assert (inorodnue tela3))))

(defrule test4
                (inorodnue tela3)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "    :     ,   
                 ,    .              .
                   (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,         .     (). " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)  
                (printout t "       .      ,   " crlf)
                (printout t "           -    " crlf)
                (printout t ".         -    " crlf)
                (printout t "     .         " crlf) 
                (printout t "   .        -   ," crlf)
                (printout t "  ,     ." crlf)        
                else
                (assert (temperatura))))

(defrule povtemperatura
               (temperatura)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "    ,  ,    ,  (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t "  :" crlf)
                (printout t " " crlf) 
                (printout t " ,        ,    " crlf)  
                (printout t "  .    .     " crlf)
                (printout t "(     ).          ." crlf)
                (printout t "    .       " crlf)
                (printout t " 7-10   ,     25-26 . .   " crlf)  
                (printout t "    ." crlf)
                else
                (assert (elektrotravma))))

(defrule test5
               (elektrotravma)
                =>
                (printout t "  " crlf) 
                (if (yes-or-no-p "   ,   .    
                   ,    , ,  
                   .    (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,        " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)
                (printout t "          ." crlf) 
                (printout t "    ,        , " crlf)  
                (printout t "     .        " crlf)
                (printout t "   ,  ,   (    - " crlf)
                (printout t " ,     -     ,   " crlf)
                (printout t ").     ,    ." crlf)
                (printout t "   ,         ." crlf) 
                (printout t "      .   , " crlf)  
                (printout t ",   .       .   ." crlf)
                (printout t "        ,     " crlf)
                (printout t ",    .          " crlf)
                (printout t "  '   '  '   '.      ,   " crlf)
                (printout t " ,    ." crlf) 
                else
                (assert (solydar))))

(defrule solnydar
               (solydar)
                =>
                (printout t "  " crlf) 
                (if (yes-or-no-p "     ,    ,  ,  . 
                        , .   ,  ,  ,
                         ,   ,    (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "    ,     . " crlf)
                (printout t "    " crlf) 
                (printout t "  : " crlf)
                (printout t " " crlf)
                (printout t "     ,     , " crlf)
                (printout t "  .      .   ." crlf)
                else
                (assert (appendiks))))

(defrule appendicit
               (appendiks)
                =>
                (printout t " " crlf) 
                (if (yes-or-no-p "     .     .
                    ,  .   , 
                 ,   . -        - 
                 ,        (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,       , ..  " crlf)
                (printout t "     ()." crlf) 
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)
                (printout t "      :" crlf) 
                (printout t "   ,     ; " crlf)  
                (printout t "  ,      ;" crlf)
                (printout t "        ." crlf)
                (printout t "       ." crlf)
                else
                (assert (otmorogenie)))) 

(defrule moroz
                (otmorogenie)
                =>
                (printout t "  " crlf) 
                (if (yes-or-no-p "    ,  .     
                                   ,   (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "       . " crlf)
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t " " crlf)
                (printout t "         .  " crlf) 
                (printout t "        .     " crlf)  
                (printout t "(, , , )  ,    .     " crlf)
                (printout t ", .     ,     , " crlf)
                (printout t "      .       (    " crlf)
                (printout t "  ).      37-38 . ,   . " crlf) 
                (printout t "     , .    " crlf)  
                (printout t "     .    I    " crlf)
                (printout t ".     :       , ." crlf)
                (printout t "   ." crlf)
                else
                (assert (otravlenie))))

(defrule otravlenierebenka
                (otravlenie)
                 =>
                (printout t "  " crlf) 
                (if (yes-or-no-p " , ,    , , , ,  ,   
                    ,  ,   (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,    : , ,  . . " crlf)
                (printout t "                  " crlf) 
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t "" crlf)
                (printout t "    ,   .  ,     , , ." crlf) 
                (printout t "        .     " crlf)  
                (printout t " .    ,     .    " crlf)
                (printout t " - .  ,   .     " crlf)
                (printout t "  , ,   .   ." crlf)
                (printout t "        .     " crlf)
                (printout t ".       , ,     .  " crlf)
                (printout t "  ,      ,      , " crlf)
                (printout t "        ,       " crlf)   
                (printout t "  .    ,     . " crlf)
                (printout t "     '   ',      .    . " crlf)
                (printout t "   .   ." crlf)            
                else
                (assert (ykys))))

(defrule ykys
                (ykys)
                =>
                (printout t "  " crlf) 
                (if (yes-or-no-p "       ,    ,  ,      
                      ,        (yes/no)? ")
                then
                (printout t "   " crlf )
                (printout t " :" crlf)
                (printout t " " crlf) 
                (printout t "  ,        . " crlf)
                (printout t "    " crlf) 
                (printout t " " crlf)   
                (printout t "  :" crlf)
                (printout t "" crlf)
                (printout t "          .    - " crlf) 
                (printout t ".     , ,  .       " crlf)  
                (printout t ",    . " crlf)
                (printout t "          .     " crlf)
                (printout t "   ,   ." crlf)
                else
                (printout t "   " crlf )
                (printout t "      ,     ,  ,    " crlf )
                (printout t "        ,    ,   " crlf )
                (printout t "    .  . " crlf )
                (assert (proba))))

(defrule probas
                (proba)
                =>
                (printout t "  " crlf)
                (if (yes-or-no-p "  (yes/no)? ")
                then
                (reset)
                (run)
                else
                (printout t " !     !      !" crlf) 
                (halt)))                                             