(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))) ?answer)

(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))

(defrule system-banner ""
                (declare (salience 10))
                =>
                 (printout t "    " crlf)
                 (printout t "                                  ***************************************" crlf)
                 (printout t "                                  *               *" crlf)
                 (printout t "                                  ***************************************" crlf)
                 (printout t "                                                                                                                " crlf)
                 (printout t "                ?     " crlf) 
                 (printout t "              (    )." crlf)
                 (printout t "               . " crlf) 
                 (printout t "       " crlf)
                     (printout t "    :" crlf)
                     (printout t "   ,   1;" crlf)
                     (printout t "  -  0." crlf)
                     (printout t "    .   ," crlf)
                     (printout t "  ,   ,    " crlf)
                     (printout t ". , -    ." crlf)
                 )


(deffacts init
           (troubleshoot-mode)
           (menu-level))

(defrule main-menu
                     (declare (salience 500))
                     (troubleshoot-mode) 
                     ?ml <- (menu-level) 
                     =>
                     (retract ?ml)
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1)    " crlf)
                     (printout t "                                2)   " crlf) 
                     (printout t "                                                                    " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response))
                     )
(defrule user-exit
                     (troubleshoot-mode)
                     (problem-response 2) 
                      =>
                     (printout t " !" crlf)
                     (halt))

(defrule begin-start
                      (troubleshoot-mode) 
                      ?pr <- (problem-response 1) 
                      =>
                      (retract ?pr)
                      (assert (defrule test)))

(defglobal ?*y* = 1)
(defglobal ?*n* = 0)

(defrule test
=>
(printout t "     " crlf)
(printout t " I " crlf) 
(if (yes-or-no-p "    ? (yes/no)? ")
then 
(assert (yes1))
(bind ?a 1)
(printout t  "      "?a " ."crlf)
else 
(assert (not1))
(bind ?b 0) 
(printout t  "      "?b " ."crlf))

(if (yes-or-no-p "     ? (yes/no)? ")
then 
(assert (yes2))
(bind ?c 1)
(printout t  "      "?c " ."crlf)
else 
(assert (not2))
(bind ?d 0) 
(printout t  "      "?d " ."crlf))

(if (yes-or-no-p "    ? (yes/no)? ")
then 
(assert (yes3))
(bind ?e 1)
(printout t  "      "?e " ."crlf)
else 
(assert (not3))
(bind ?f 0) 
(printout t  "      "?f " ."crlf))
)

(defrule result1
(yes1) 
(yes2)
(yes3)
=>
(printout t  "     : " ?*y* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sum1)))

(defrule result2
(yes1) 
(yes2)
(not3)
=>
(printout t  "     : " ?*y* ?*y* ?*n* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sum1)))

(defrule result3
(yes1) 
(not2)
(yes3) 
=>
(printout t  "     : " ?*y* ?*n* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sum1)))

(defrule result4
(yes1) 
(not2)
(not3) 
=>
(printout t  "     : " ?*y* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sum0)))

(defrule result5
(not1) 
(yes2)
(yes3)
=>
(printout t  "     : " ?*n* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sum1)))

(defrule result6
(not1) 
(yes2)
(not3)
=>
(printout t  "     : " ?*n* ?*y* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sum0)))

(defrule result7
(not1) 
(not2)
(yes3)
=>
(printout t  "     : " ?*n* ?*n* ?*y* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sum0)))

(defrule result8
(not1) 
(not2)
(not3)
=>
(printout t  "     : " ?*n* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sum0)))

(defrule test2
=>
(printout t "     " crlf)
(printout t " II " crlf) 
(if (yes-or-no-p "     ? (yes/no)? ")
then 
(assert (yes4))
(bind ?a 1)
(printout t  "      "?a " ."crlf)
else 
(assert (not4))
(bind ?b 0) 
(printout t  "      "?b " ."crlf))

(if (yes-or-no-p "      ? (yes/no)? ")
then 
(assert (yes5))
(bind ?c 1)
(printout t  "      "?c " ."crlf)
else 
(assert (not5))
(bind ?d 0) 
(printout t  "      "?d " ."crlf))

(if (yes-or-no-p "  ? (yes/no)? ")
then 
(assert (yes6))
(bind ?e 1)
(printout t  "      "?e " ."crlf)
else 
(assert (not6))
(bind ?f 0) 
(printout t  "      "?f " ."crlf))
)

(defrule result9
(yes4) 
(yes5)
(yes6)
=>
(printout t  "     : " ?*y* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sums1)))

(defrule result10
(yes4) 
(yes5)
(not6)
=>
(printout t  "     : " ?*y* ?*y* ?*n* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sums1)))

(defrule result11
(yes4) 
(not5)
(yes6) 
=>
(printout t  "     : " ?*y* ?*n* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sums1)))

(defrule result12
(yes4) 
(not5)
(not6) 
=>
(printout t  "     : " ?*y* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sums0)))

(defrule result13
(not4) 
(yes5)
(yes6)
=>
(printout t  "     : " ?*n* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sums1)))

(defrule result14
(not4) 
(yes5)
(not6)
=>
(printout t  "     : " ?*n* ?*y* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sums0)))

(defrule result15
(not4) 
(not5)
(yes6)
=>
(printout t  "     : " ?*n* ?*n* ?*y* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sums0)))

(defrule result16
(not4) 
(not5)
(not6)
=>
(printout t  "     : " ?*n* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sums0)))

(defrule test3
=>
(printout t "     " crlf)
(printout t " III " crlf) 
(if (yes-or-no-p "  ,   ? (yes/no)? ")
then 
(assert (yes7))
(bind ?a 1)
(printout t  "      "?a " ."crlf)
else 
(assert (not7))
(bind ?b 0) 
(printout t  "      "?b " ."crlf))

(if (yes-or-no-p "   ? (yes/no)? ")
then 
(assert (yes8))
(bind ?c 1)
(printout t  "      "?c " ."crlf)
else 
(assert (not8))
(bind ?d 0) 
(printout t  "      "?d " ."crlf))

(if (yes-or-no-p "       ? (yes/no)? ")
then 
(assert (yes9))
(bind ?e 1)
(printout t  "      "?e " ."crlf)
else 
(assert (not9))
(bind ?f 0) 
(printout t  "      "?f " ."crlf))
)

(defrule result17
(yes7) 
(yes8)
(yes9)
=>
(printout t  "     : " ?*y* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (suma1)))

(defrule result18
(yes7) 
(yes8)
(not9)
=>
(printout t  "     : " ?*y* ?*y* ?*n* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (suma1)))

(defrule result19
(yes7) 
(not8)
(yes9) 
=>
(printout t  "     : " ?*y* ?*n* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (suma1)))

(defrule result20
(yes7) 
(not8)
(not9) 
=>
(printout t  "     : " ?*y* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (suma0)))

(defrule result21
(not7) 
(yes8)
(yes9)
=>
(printout t  "     : " ?*n* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (suma1)))

(defrule result22
(not7) 
(yes8)
(not9)
=>
(printout t  "     : " ?*n* ?*y* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (suma0)))

(defrule result23
(not7) 
(not8)
(yes9)
=>
(printout t  "     : " ?*n* ?*n* ?*y* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (suma0)))

(defrule result24
(not7) 
(not8)
(not9)
=>
(printout t  "     : " ?*n* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (suma0)))

(defrule test4
=>
(printout t "     " crlf)
(printout t " IV " crlf) 
(if (yes-or-no-p "      ? (yes/no)? ")
then 
(assert (yes10))
(bind ?a 1)
(printout t  "      "?a " ."crlf)
else 
(assert (not10))
(bind ?b 0) 
(printout t  "      "?b " ."crlf))

(if (yes-or-no-p "     ? (yes/no)? ")
then 
(assert (yes11))
(bind ?c 1)
(printout t  "      "?c " ."crlf)
else 
(assert (not11))
(bind ?d 0) 
(printout t  "      "?d " ."crlf))

(if (yes-or-no-p "     ? (yes/no)? ")
then 
(assert (yes12))
(bind ?e 1)
(printout t  "      "?e " ."crlf)
else 
(assert (not12))
(bind ?f 0) 
(printout t  "      "?f " ."crlf))
)

(defrule result25
(yes10) 
(yes11)
(yes12)
=>
(printout t  "     : " ?*y* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sumas1)))

(defrule result26
(yes10) 
(yes11)
(not12)
=>
(printout t  "     : " ?*y* ?*y* ?*n* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sumas1)))

(defrule result27
(yes10) 
(not11)
(yes12) 
=>
(printout t  "     : " ?*y* ?*n* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sumas1)))

(defrule result28
(yes10) 
(not11)
(not12) 
=>
(printout t  "     : " ?*y* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sumas0)))

(defrule result29
(not10) 
(yes11)
(yes12)
=>
(printout t  "     : " ?*n* ?*y* ?*y* " "crlf )
(printout t  "       "?*y*"       "?*y*" ."crlf )
(assert (sumas1)))

(defrule result30
(not10) 
(yes11)
(not12)
=>
(printout t  "     : " ?*n* ?*y* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sumas0)))

(defrule result31
(not10) 
(not11)
(yes12)
=>
(printout t  "     : " ?*n* ?*n* ?*y* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sumas0)))

(defrule result32
(not10) 
(not11)
(not12)
=>
(printout t  "     : " ?*n* ?*n* ?*n* " "crlf )
(printout t  "       "?*n*"       "?*n*" ."crlf )
(assert (sumas0)))

(defrule zagal
(sum1)
(sums1)
(suma1)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*y* ?*y* ?*y* " "crlf )
(printout t  "  ,   - , ,      ."crlf ))

(defrule zagal2
(sum1)
(sums0)
(suma0)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*n* ?*n* ?*n* " "crlf )
(printout t  "  ,   - , , ,   ."crlf ))

(defrule zagal3
(sum1)
(sums0)
(suma0)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*n* ?*n* ?*y* " "crlf )
(printout t  "  ,   - , , ,   ."crlf ))

(defrule zagal4
(sum1)
(sums0)
(suma1)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*n* ?*y* ?*y* " "crlf )
(printout t  "  ,   - , ,  , ."crlf ))

(defrule zagal5
(sum0)
(sums1)
(suma1)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*y* ?*y* ?*y* " "crlf )
(printout t  "  ,   - , ,    ,  ."crlf ))

(defrule zagal6
(sum0)
(sums1)
(suma1)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*y* ?*y* ?*n* " "crlf )
(printout t  "  ,   - , , ."crlf ))

(defrule zagal7
(sum0)
(sums1)
(suma0)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*y* ?*n* ?*n* " "crlf )
(printout t  "  ,   - , , , , , ."crlf ))

(defrule zagal8
(sum0)
(sums0)
(suma0)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*n* ?*n* ?*n* " "crlf )
(printout t  "  ,   - , ,          ."crlf ))

(defrule zagal9
(sum1)
(sums0)
(suma1)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*n* ?*y* ?*n* " "crlf )
(printout t  "  ,   -   ,      ,   ."crlf ))

(defrule zagal10
(sum1)
(sums1)
(suma1)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*y* ?*y* ?*n* " "crlf )
(printout t  "  ,   - ,        , ."crlf ))

(defrule zagal11
(sum1)
(sums1)
(suma0)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*y* ?*n* ?*n* " "crlf )
(printout t  "  ,   - , ,    ,    " crlf)
(printout t  "   ,   -    - ."crlf ))

(defrule zagal12
(sum0)
(sums0)
(suma0)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*n* ?*n* ?*y* " "crlf )
(printout t  "  ,   - ,   ,       " crlf)
(printout t  "   ."crlf ))

(defrule zagal13
(sum0)
(sums0)
(suma1)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*n* ?*y* ?*y* " "crlf )
(printout t  "  ,   -   ,    , ."crlf ))

(defrule zagal14
(sum0)
(sums1)
(suma0)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*y* ?*n* ?*y* " "crlf )
(printout t  "  ,   - ,   :        , " crlf)
(printout t  " , ,  ,  ."crlf ))

(defrule zagal15
(sum1)
(sums1)
(suma0)
(sumas1)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*y* ?*y* ?*n* ?*y* " "crlf )
(printout t  "  ,   - , ,      ;   ."crlf ))

(defrule zagal16
(sum0)
(sums0)
(suma1)
(sumas0)
=>
(printout t "     " crlf)
(printout t "                                 :   " crlf)
(printout t "     " crlf)
(printout t  "       : " ?*n* ?*n* ?*y* ?*n* " "crlf )
(printout t  "  ,   - , ,   ."crlf ))
