(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))) ?answer)

(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))

(deffacts init
           (troubleshoot-mode)
           (menu-level) 
           )
(defrule main-menu
                     (declare (salience 500))
                     (troubleshoot-mode) 
                     ?ml <- (menu-level)
                     =>
                     (retract ?ml) 
                     (printout t "                                     !" crlf)
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1) " crlf)
                     (printout t "                                2) " crlf) 
                     (printout t "                                3) " crlf) 
                     (printout t "                                4) " crlf)
                     (printout t "                                5) " crlf) 
                     (printout t "                                6) " crlf) 
                     (printout t "                                7) " crlf) 
                     (printout t "                                8) " crlf) 
                     (printout t "                                9) " crlf) 
                     (printout t "                                10) " crlf) 
                     (printout t "                                11) " crlf)
                     (printout t "                                12)  " crlf)
                     (printout t "                                13)   " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response))
                     )
(defrule main-menu2
                     (problem-response 1) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                a)     " crlf)
                     (printout t "                                b)     " crlf) 
                     (printout t "                                c)     " crlf) 
                     (printout t "                                d)     " crlf)
                     (printout t "                                e)     " crlf) 
                     (printout t "                                i)     " crlf)
                     (printout t "                                j)     " crlf)
                     (printout t "                                f)     " crlf) 
                     (printout t "                                g)     " crlf) 
                     (printout t "                                h)     " crlf) 
                     (printout t "                                k)     " crlf) 
                     (printout t "                                l)     " crlf) 
                     (printout t "                                m)     " crlf)
                     (printout t "                                n)     " crlf)
	     (printout t "                                o)     " crlf)
                     (printout t "                                p)     " crlf)
                     (printout t "                                r)     " crlf)
                     (printout t "                                s)     " crlf)
                     (printout t "                                t)     " crlf)
                     (printout t "                                q)     " crlf)
                     (printout t "                                u)     " crlf)
                     (printout t "                                v)     " crlf)
                     (printout t "                                w)     " crlf)
                     (printout t "                                x)     " crlf)
                     (printout t "                                y)     " crlf)
                     (printout t "                                z)     " crlf)
                     (printout t "                                ab)    " crlf)
                     (printout t "                                bc)    " crlf)
                     (printout t "                                cd)     " crlf)
                     (printout t "                               de)     " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )
(defrule valuta1
                     (problem-response a) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x (read))
                     (assert (x ?x))
                     (printout t "  .:" crlf)
                     (bind ?y (read))
                     (assert (y ?y)) 
                     )
(defrule razchet
                     (x ?x)
                     (y ?y) 
                     =>
                     (printout t "     .       .: " (* ?x ?y) " ." crlf)
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta2
                     (problem-response b) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x2 (read))
                     (assert (x2 ?x2))
                     (printout t "  .:" crlf)
                     (bind ?y2 (read))
                     (assert (y2 ?y2)) 
                     )
(defrule razchet2
                     (x2 ?x2)
                     (y2 ?y2) 
                     =>
                     (printout t "     .       ..: " (/ ?x2 ?y2) " .." crlf)
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta3
                     (problem-response c) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?x3 (read))
                     (assert (x3 ?x3))
                     (printout t "   :" crlf)
                     (bind ?y3 (read))
                     (assert (y3 ?y3)) 
                     )
(defrule razchet3
                     (x3 ?x3)
                     (y3 ?y3) 
                     =>
                    (printout t "     .       .: " (* ?x3 ?y3) " ." crlf)
                    (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))       

(defrule valuta4
                     (problem-response d) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x4 (read))
                     (assert (x4 ?x4))
                     (printout t "   :" crlf)
                     (bind ?y4 (read))
                     (assert (y4 ?y4)) 
                     )
(defrule razchet4
                     (x4 ?x4)
                     (y4 ?y4) 
                     =>
 (printout t "     .       .: " (/ ?x4 ?y4) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))   

(defrule valuta5
                     (problem-response e) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?x5 (read))
                     (assert (x5 ?x5))
                     (printout t "   :" crlf)
                     (bind ?y5 (read))
                     (assert (y5 ?y5)) 
                     )
(defrule razchet5
                     (x5 ?x5)
                     (y5 ?y5) 
                     =>
                     (printout t "      .       .: " (* ?x5 ?y5) " ."crlf)
                      (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta6
                     (problem-response i) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x6 (read))
                     (assert (x6 ?x6))
                     (printout t "   :" crlf)
                     (bind ?y6 (read))
                     (assert (y6 ?y6)) 
                     )
(defrule razchet6
                     (x6 ?x6)
                     (y6 ?y6) 
                     =>
     (printout t "     .       .: " (/ ?x6 ?y6) " ." crlf)
      (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta7
                     (problem-response j) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?x7 (read))
                     (assert (x7 ?x7))
                     (printout t "   :" crlf)
                     (bind ?y7 (read))
                     (assert (y7 ?y7)) 
                     )
(defrule razchet7
                     (x7 ?x7)
                     (y7 ?y7) 
                     =>
       (printout t "     .       .: " (* ?x7 ?y7) " ." crlf)
        (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta8
                     (problem-response f) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x8 (read))
                     (assert (x8 ?x8))
                     (printout t "   :" crlf)
                     (bind ?y8 (read))
                     (assert (y8 ?y8)) 
                     )
(defrule razchet8
                     (x8 ?x8)
                     (y8 ?y8) 
                     =>
  (printout t "     .        : " (/ ?x8 ?y8) "  " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta9
                     (problem-response g) 
                     =>
                     (printout t "     :" crlf)
                     (bind ?x9 (read))
                     (assert (x9 ?x9))
                     (printout t "   :" crlf)
                     (bind ?y9 (read))
                     (assert (y9 ?y9)) 
                     )
(defrule razchet9
                     (x9 ?x9)
                     (y9 ?y9) 
                     =>
  (printout t "     .       .: " (* ?x9 ?y9) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta10
                     (problem-response h) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x10 (read))
                     (assert (x10 ?x10))
                     (printout t "   :" crlf)
                     (bind ?y10 (read))
                     (assert (y10 ?y10)) 
                     )
(defrule razchet10
                     (x10 ?x10)
                     (y10 ?y10) 
                     =>
(printout t "     .       .: " (/ ?x10 ?y10) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta11
                     (problem-response k) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x11 (read))
                     (assert (x11 ?x11))
                     (printout t "   :" crlf)
                     (bind ?y11 (read))
                     (assert (y11 ?y11)) 
                     )
(defrule razchet11
                     (x11 ?x11)
                     (y11 ?y11) 
                     =>
  (printout t "     .       .: " (* ?x11 ?y11) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta12
                     (problem-response l) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x12 (read))
                     (assert (x12 ?x12))
                     (printout t "   :" crlf)
                     (bind ?y12 (read))
                     (assert (y12 ?y12)) 
                     )
(defrule razchet12
                     (x12 ?x12)
                     (y12 ?y12) 
                     =>
(printout t "     .       .: " (/ ?x12 ?y12) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta13
                     (problem-response m) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x13 (read))
                     (assert (x13 ?x13))
                     (printout t "   :" crlf)
                     (bind ?y13 (read))
                     (assert (y13 ?y13)) 
                     )
(defrule razchet13
                     (x13 ?x13)
                     (y13 ?y13) 
                     =>
(printout t "     .       .: " (* ?x13 ?y13) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta14
                     (problem-response n) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x14 (read))
                     (assert (x14 ?x14))
                     (printout t "   :" crlf)
                     (bind ?y14 (read))
                     (assert (y14 ?y14)) 
                     )
(defrule razchet14
                     (x14 ?x14)
                     (y14 ?y14) 
                     =>
(printout t "     .       : " (/ ?x14 ?y14) " " crlf) 
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta15
                     (problem-response o) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x15 (read))
                     (assert (x15 ?x15))
                     (printout t "  :" crlf)
                     (bind ?y15 (read))
                     (assert (y15 ?y15)) 
                     )
(defrule razchet15
                     (x15 ?x15)
                     (y15 ?y15) 
                     =>
            (printout t "    .       .: " (* ?x15 ?y15) " ." crlf)
            (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta16
                     (problem-response p) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x16 (read))
                     (assert (x16 ?x16))
                     (printout t "  :" crlf)
                     (bind ?y16 (read))
                     (assert (y16 ?y16)) 
                     )
(defrule razchet16
                     (x16 ?x16)
                     (y16 ?y16) 
                     =>
(printout t "     .       .: " (/ ?x16 ?y16) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta17
                     (problem-response r) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x17 (read))
                     (assert (x17 ?x17))
                     (printout t "   :" crlf)
                     (bind ?y17 (read))
                     (assert (y17 ?y17)) 
                     )
(defrule razchet17
                     (x17 ?x17)
                     (y17 ?y17) 
                     =>
  (printout t "    .       .: " (* ?x17 ?y17) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta18
                     (problem-response s) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x18 (read))
                     (assert (x18 ?x18))
                     (printout t "   :" crlf)
                     (bind ?y18 (read))
                     (assert (y18 ?y18)) 
                     )
(defrule razchet18
                     (x18 ?x18)
                     (y18 ?y18) 
                     =>
(printout t "    .       : " (/ ?x18 ?y18) " " crlf) 
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))      

(defrule valuta19
                     (problem-response t) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x19 (read))
                     (assert (x19 ?x19))
                     (printout t "   :" crlf)
                     (bind ?y19 (read))
                     (assert (y19 ?y19)) 
                     )
(defrule razchet19
                     (x19 ?x19)
                     (y19 ?y19) 
                     =>
(printout t "  .  .       .: " (* ?x19 ?y19) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))      

(defrule valuta20
                     (problem-response q) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x20 (read))
                     (assert (x20 ?x20))
                     (printout t "   :" crlf)
                     (bind ?y20 (read))
                     (assert (y20 ?y20)) 
                     )
(defrule razchet20
                     (x20 ?x20)
                     (y20 ?y20) 
                     =>
(printout t "    ..       .: " (/ ?x20 ?y20) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))      

(defrule valuta21
                     (problem-response u) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x21 (read))
                     (assert (x21 ?x21))
                     (printout t "   :" crlf)
                     (bind ?y21 (read))
                     (assert (y21 ?y21)) 
                     )
(defrule razchet21
                     (x21 ?x21)
                     (y21 ?y21) 
                     =>
 (printout t "     .       .: " (* ?x21 ?y21) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta22
                     (problem-response v) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x22 (read))
                     (assert (x22 ?x22))
                     (printout t "   :" crlf)
                     (bind ?y22 (read))
                     (assert (y22 ?y22)) 
                     )
(defrule razchet22
                     (x22 ?x22)
                     (y22 ?y22) 
                     =>
 (printout t "     .       .: " (/ ?x22 ?y22) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))     

(defrule valuta23
                     (problem-response w) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x23 (read))
                     (assert (x23 ?x23))
                     (printout t "   :" crlf)
                     (bind ?y23 (read))
                     (assert (y23 ?y23)) 
                     )
(defrule razchet23
                     (x23 ?x23)
                     (y23 ?y23) 
                     =>
 (printout t "     .       .: " (* ?x23 ?y23) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))      

(defrule valuta24
                     (problem-response x) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x24 (read))
                     (assert (x24 ?x24))
                     (printout t "   :" crlf)
                     (bind ?y24 (read))
                     (assert (y24 ?y24)) 
                     )
(defrule razchet24
                     (x24 ?x24)
                     (y24 ?y24) 
                     =>
(printout t "     .       .: " (/ ?x24 ?y24) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))      

(defrule valuta25
                     (problem-response y) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x25 (read))
                     (assert (x25 ?x25))
                     (printout t "   :" crlf)
                     (bind ?y25 (read))
                     (assert (y25 ?y25)) 
                     )
(defrule razchet25
                     (x25 ?x25)
                     (y25 ?y25) 
                     =>
  (printout t "  .  .       .: " (* ?x25 ?y25) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta26
                     (problem-response z) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x26 (read))
                     (assert (x26 ?x26))
                     (printout t "   :" crlf)
                     (bind ?y26 (read))
                     (assert (y26 ?y26)) 
                     )
(defrule razchet26
                     (x26 ?x26)
                     (y26 ?y26) 
                     =>
(printout t "     .       : " (/ ?x26 ?y26) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta27
                     (problem-response ab) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x27 (read))
                     (assert (x27 ?x27))
                     (printout t "  :" crlf)
                     (bind ?y27 (read))
                     (assert (y27 ?y27)) 
                     )
(defrule razchet27
                     (x27 ?x27)
                     (y27 ?y27) 
                     =>
     (printout t "    .       .: " (* ?x27 ?y27) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule valuta28
                     (problem-response bc) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x28 (read))
                     (assert (x28 ?x28))
                     (printout t "  :" crlf)
                     (bind ?y28 (read))
                     (assert (y28 ?y28)) 
                     )
(defrule razchet28
                     (x28 ?x28)
                     (y28 ?y28) 
                     =>
 (printout t "    .       : " (/ ?x28 ?y28) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta29
                     (problem-response cd) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?x29 (read))
                     (assert (x29 ?x29))
                     (printout t "   :" crlf)
                     (bind ?y29 (read))
                     (assert (y29 ?y29)) 
                     (printout t "  :" crlf)
                     (bind ?z29 (read))
                     (assert (z29 ?z29)) 
                     )
(defrule razchet29
                     (x29 ?x29)
                     (y29 ?y29)
                     (z29 ?z29) 
                     =>
(printout t "     .       : " (/ (* ?x29 ?y29) ?z29) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule valuta30
                     (problem-response de) 
                     =>
                     (printout t "   :" crlf)
                     (bind ?x30 (read))
                     (assert (x30 ?x30))
                     (printout t "  :" crlf)
                     (bind ?y30 (read))
                     (assert (y30 ?y30))
                     (printout t "   :" crlf)
                     (bind ?z30 (read))
                     (assert (z30 ?z30))  
                     )
(defrule razchet30
                     (x30 ?x30)
                     (y30 ?y30) 
                     (z30 ?z30)
                     =>
 (printout t "     .        : " (/ (* ?x30 ?y30) ?z30) "  " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule main-menu3
                     (problem-response 2) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                day)   ()  (, ) " crlf)
                     (printout t "                                min)    " crlf)
                     (printout t "                                clok)    ()" crlf)
                     (printout t "                                ned)    (, , )" crlf)
                     (printout t "                                god)    (, , , , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  

(defrule days
                     (problem-response day) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?x (read))
                     (assert (x ?x))
                     )
(defrule itog
                     (x ?x)
                     =>
                     (printout t "  " ?x " () - " (* ?x 86400) " " crlf)
                     (printout t "  " ?x " () - " (* ?x 1440) " " crlf)
                     (printout t "  " ?x " () - " (* ?x 24) " ()" crlf)
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))
                     
(defrule mins
                     (problem-response min) 
                     =>
                     (printout t " :" crlf)
                     (bind ?y (read))
                     (assert (y ?y))
                     )
(defrule itog2
                     (y ?y)
                     =>
                     (printout t "  " ?y " () - "  (* ?y 60) " " crlf)
                      (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule cloks
                     (problem-response clok) 
                     =>
                     (printout t " :" crlf)
                     (bind ?z (read))
                     (assert (z ?z))
                     )
(defrule itog3
                     (z ?z)
                     =>
                    (printout t "  " ?z " () - " (* ?z 3600) " " crlf)
                    (printout t "  " ?z " () - " (* ?z 60) " " crlf)
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))       

(defrule neds
                     (problem-response ned) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?n (read))
                     (assert (n ?n))
                     )
(defrule itog4
                     (n ?n)
                     =>
  (printout t "  "  ?n " () - " (* ?n 604800) " " crlf)
  (printout t "  "  ?n " () - " (* ?n 10080) " " crlf)
  (printout t "  "  ?n " () - " (* ?n 168) " " crlf)
  (printout t "  "  ?n " () - " (* ?n 7) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))    

(defrule gods
                     (problem-response god) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?g (read))
                     (assert (g ?g))
                     )
(defrule itog5
                     (g ?g)
                      =>
                     (printout t "  " ?g " () - " (* ?g 31557600) " "crlf)
                     (printout t "  " ?g " () - " (* ?g 525960) " "crlf)
                     (printout t "  " ?g " () - " (* ?g 8766) " "crlf)
                     (printout t "  " ?g " () - " (* ?g 365) " "crlf)
                     (printout t "  " ?g " () - " (* ?g 52) " "crlf) 
                     (printout t "  " ?g " () - " (* ?g 12) " "crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 

(defrule main-menu4
                     (problem-response 3) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                bar)    (, , , /.) " crlf)
                     (printout t "                                atm)    (, , , /.)" crlf)
                     (printout t "                                pas)    (, /.)" crlf)
                     (printout t "                                tor)    (, , , /.)" crlf)
                     (printout t "                                fun)  /.  (, , , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  

(defrule bars
                     (problem-response bar) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?bar (read))
                     (assert (bar ?bar))
                     )
(defrule itog6
                     (bar ?bar)
                     =>
                     (printout t  ?bar "  - " (* ?bar 0.98692326) " " crlf)
                     (printout t  ?bar "  - " (* ?bar 100000) " " crlf)
                     (printout t  ?bar "  - " (* ?bar 750.064) " " crlf)
                     (printout t  ?bar "  - " (* ?bar 14.50) " /." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))  
                   
(defrule atms
                     (problem-response atm) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?atm (read))
                     (assert (atm ?atm))
                     )
(defrule itog7
                     (atm ?atm)
                     =>
                     (printout t  ?atm "  - " (* ?atm 1.01325) " " crlf)
                     (printout t  ?atm "  - " (* ?atm 101325) " " crlf)
                     (printout t  ?atm "  - " (* ?atm 760) " " crlf)
                     (printout t  ?atm "  - " (* ?atm 14.695949) " /." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt))) 
(defrule pass
                     (problem-response pas) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?pas (read))
                     (assert (pas ?pas))
                     )
(defrule itog8
                     (pas ?pas)
                     =>
                     (printout t  ?pas "  - " (* ?pas 0.0075) " " crlf)
                     (printout t  ?pas "  - " (* ?pas 0.00014503) " /." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))  

(defrule tors
                     (problem-response tor) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?tor (read))
                     (assert (tor ?tor))
                     )
(defrule itog9
                     (tor ?tor)
                     =>
                     (printout t  ?tor "  - " (* ?tor 0.00131578) " " crlf)
                     (printout t  ?tor "  - " (* ?tor 0.0013) " " crlf)
                     (printout t  ?tor "  - " (* ?tor 133.322) " " crlf)
                     (printout t  ?tor "  - " (* ?tor 0.019) " /." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))  
(defrule funs
                     (problem-response fun) 
                     =>
                     (printout t "    /.:" crlf)
                     (bind ?fun (read))
                     (assert (fun ?fun))
                     )
(defrule itog10
                     (fun ?fun)
                      =>
                     (printout t  ?fun " /. - " (* ?fun 0.06804596) " " crlf)
                     (printout t  ?fun " /. - " (* ?fun 0.06894757) " " crlf)
                     (printout t  ?fun " /. - " (* ?fun 6894.75) " " crlf)
                     (printout t  ?fun " /. - " (* ?fun 51.7151) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu5
                     (problem-response 4) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "    km)    (, , , ,  , , , ) " crlf)
                     (printout t "    mili)    (, , , ,  , , , )" crlf)
                     (printout t "    mmili)     (, , , , , , , )" crlf)
                     (printout t "    fut)    (, , , ,  , , , )" crlf)
                     (printout t "    yard)    (, , , ,  , , , )" crlf)
                     (printout t "    metr)    (, , , ,  , , , )" crlf)
                     (printout t "    milim)    (, , , , )" crlf)
                     (printout t "    san)    (, , , , , )" crlf)
                     (printout t "    dyum)    (, , , , ,  , , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule kms
                     (problem-response km) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?km (read))
                     (assert (km ?km))
                     )
(defrule itog11
                     (km ?km)
                     =>
                     (printout t  ?km "  - " (* ?km 3280.839895) " (,)" crlf)
                     (printout t  ?km "  - " (* ?km 1093.613298) " (,)" crlf)
                     (printout t  ?km "  - " (* ?km 1000) " ()" crlf)
                     (printout t  ?km "  - " (* ?km 0.6213712) " " crlf)
                     (printout t  ?km "  - " (* ?km 0.5399568) " () " crlf)
                     (printout t  ?km "  - " (* ?km 1000000) " ()" crlf)
                     (printout t  ?km "  - " (* ?km 100000) " ()" crlf)
                     (printout t  ?km "  - " (* ?km 39370.07874) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule milis
                     (problem-response mili) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?mili (read))
                     (assert (mili ?mili))
                     )
(defrule itog12
                     (mili ?mili)
                     =>
                     (printout t  ?mili "  - " (* ?mili 5279.999934) " (,)" crlf)
                     (printout t  ?mili "  - " (* ?mili 1759.999978) " (,)" crlf)
                     (printout t  ?mili "  - " (* ?mili 1609.34398) " ()" crlf)
                     (printout t  ?mili "  - " (* ?mili 1.60934398) " ()" crlf)
                     (printout t  ?mili "  - " (* ?mili 0.86897622) " () " crlf)
                     (printout t  ?mili "  - " (* ?mili 1609343.98) " ()" crlf)
                     (printout t  ?mili "  - " (* ?mili 160934.398) " ()" crlf)
                     (printout t  ?mili "  - " (* ?mili 63359.99921) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule mmilis
                     (problem-response mmili) 
                     =>
                     (printout t "     :" crlf)
                     (bind ?mmili (read))
                     (assert (mmili ?mmili))
                     )
(defrule itog13
                     (mmili ?mmili)
                     =>
                     (printout t  ?mmili "   - " (* ?mmili 6076.115524) " (,)" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 2025.371841) " (,)" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 1852.000012) " ()" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 1.8520) " ()" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 1.1508) " " crlf)
                     (printout t  ?mmili "   - " (* ?mmili 1852000.012) " ()" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 185200.0012) " ()" crlf)
                     (printout t  ?mmili "   - " (* ?mmili 72913.38629) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule futs
                     (problem-response fut) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?fut (read))
                     (assert (fut ?fut))
                     )
(defrule itog14
                     (fut ?fut)
                     =>
                     (printout t  ?fut "  - " (* ?fut 0.33) " (,)" crlf)
                     (printout t  ?fut "  - " (* ?fut 0.3048) " ()" crlf)
                     (printout t  ?fut "  - " (* ?fut 0.0003048) " ()" crlf)
                     (printout t  ?fut "  - " (* ?fut 0.00018939) " " crlf)
                     (printout t  ?fut "  - " (* ?fut 0.00016457) " () " crlf)
                     (printout t  ?fut "  - " (* ?fut 304.8) " ()" crlf)
                     (printout t  ?fut "  - " (* ?fut 30.48) " ()" crlf)
                     (printout t  ?fut "  - " (* ?fut 12) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule yards
                     (problem-response yard) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?yard (read))
                     (assert (yard ?yard))
                     )
(defrule itog15
                     (yard ?yard)
                     =>
                     (printout t  ?yard "  - " (* ?yard 3) " (,)" crlf)
                     (printout t  ?yard "  - " (* ?yard 0.9144) " ()" crlf)
                     (printout t  ?yard "  - " (* ?yard 0.0009144) " ()" crlf)
                     (printout t  ?yard "  - " (* ?yard 0.00056818) " " crlf)
                     (printout t  ?yard "  - " (* ?yard 0.00049373) " () " crlf)
                     (printout t  ?yard "  - " (* ?yard 914.4) " ()" crlf)
                     (printout t  ?yard "  - " (* ?yard 91.44) " ()" crlf)
                     (printout t  ?yard "  - " (* ?yard 36) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule metrs
                     (problem-response metr) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?metr (read))
                     (assert (metr ?metr))
                     )
(defrule itog16
                     (metr ?metr)
                     =>
                     (printout t  ?metr "  - " (* ?metr 1.09361) " (,)" crlf)
                     (printout t  ?metr "  - " (* ?metr 3.281) " (,)" crlf)
                     (printout t  ?metr "  - " (* ?metr 0.001) " ()" crlf)
                     (printout t  ?metr "  - " (* ?metr 0.00062137) " " crlf)
                     (printout t  ?metr "  - " (* ?metr 0.00054) " () " crlf)
                     (printout t  ?metr "  - " (* ?metr 1000) " ()" crlf)
                     (printout t  ?metr "  - " (* ?metr 100) " ()" crlf)
                     (printout t  ?metr "  - " (* ?metr 39.37) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule milims
                     (problem-response milim) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?milim (read))
                     (assert (milim ?milim))
                     )
(defrule itog17
                     (milim ?milim)
                     =>
                     (printout t  ?milim "  - " (* ?milim 0.00109361) " (,)" crlf)
                     (printout t  ?milim "  - " (* ?milim 0.00328083) " (,)" crlf)
                     (printout t  ?milim "  - " (* ?milim 0.001) " (,)" crlf)
                     (printout t  ?milim "  - " (* ?milim 0.1) " (,)" crlf)
                     (printout t  ?milim "  - " (* ?milim 0.03937007) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule sans
                     (problem-response san) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?san (read))
                     (assert (san ?san))
                     )
(defrule itog18
                     (san ?san)
                     =>
                     (printout t  ?san "  - " (* ?san 0.01093613) " (,)" crlf)
                     (printout t  ?san "  - " (* ?san 0.03280839) " (,)" crlf)
                     (printout t  ?san "  - " (* ?san 0.01) " ()" crlf)
                     (printout t  ?san "  - " (* ?san 0.00001) " ()" crlf)
                     (printout t  ?san "  - " (* ?san 10) " ()" crlf)
                     (printout t  ?san "  - " (* ?san 0.39370078) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule dyums
                     (problem-response dyum) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?dyum (read))
                     (assert (dyum ?dyum))
                     )
(defrule itog19
                     (dyum ?dyum)
                     =>
                     (printout t  ?dyum " (,) - " (* ?dyum 0.028) " (,)" crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 0.083) " (,)" crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 0.0254) " ()" crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 0.0000254) " ()" crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 0.00001578) " " crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 0.00001371) " () " crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 25.4) " ()" crlf)
                     (printout t  ?dyum " (,) - " (* ?dyum 2.54) " ()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu6
                     (problem-response 5) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "    kk)    (, , -, -, -, ) " crlf)
                     (printout t "    dg)    (, , -, -, )" crlf)
                     (printout t "    kdg)    (, , -, -, -, )" crlf)
                     (printout t "    vs)  -  (, , , -, )" crlf)
                     (printout t "    vch)  -  (, , , -, -, )" crlf)
                     (printout t "    kvch)  -  (, , , -, -, )" crlf)
                     (printout t "    kal)    (, , , -, -)" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule kks
                     (problem-response kk) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kk (read))
                     (assert (kk ?kk))
                     )
(defrule itog20
                     (kk ?kk)
                     =>
                     (printout t  ?kk "  - " (* ?kk 4185.8) " " crlf)
                     (printout t  ?kk "  - " (* ?kk 4.1858) " " crlf)
                     (printout t  ?kk "  - " (* ?kk 4185.8) " -" crlf)
                     (printout t  ?kk "  - " (* ?kk 1.16272) " -" crlf)
                     (printout t  ?kk "  - " (* ?kk 0.00116272) " -" crlf)
                     (printout t  ?kk "  - " (* ?kk 1000) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule dgs
                     (problem-response dg) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?dg (read))
                     (assert (dg ?dg))
                     )
(defrule itog21
                     (dg ?dg)
                     =>
                     (printout t  ?dg "  - " (* ?dg 0.00023890) " " crlf)
                     (printout t  ?dg "  - " (* ?dg 0.001) " " crlf)
                     (printout t  ?dg "  - " (* ?dg 1) " -" crlf)
                     (printout t  ?dg "  - " (* ?dg 0.00028) " -" crlf)
                     (printout t  ?dg "  - " (* ?dg 0.23890295) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kdgs
                     (problem-response kdg) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kdg (read))
                     (assert (kdg ?kdg))
                     )
(defrule itog22
                     (kdg ?kdg)
                     =>
                     (printout t  ?kdg "  - " (* ?kdg 0.23890295) " " crlf)
                     (printout t  ?kdg "  - " (* ?kdg 1000) " " crlf)
                     (printout t  ?kdg "  - " (* ?kdg 1000) " -" crlf)
                     (printout t  ?kdg "  - " (* ?kdg 0.28) " -" crlf)
                     (printout t  ?kdg "  - " (* ?kdg 0.00028) " -" crlf)
                     (printout t  ?kdg "  - " (* ?kdg 0.23890295) " " crlf) 
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule  vss
                     (problem-response  vs) 
                     =>
                     (printout t "    -:" crlf)
                     (bind ?vs (read))
                     (assert ( vs ?vs))
                     )
(defrule itog23
                     ( vs ?vs)
                     =>
                     (printout t  ?vs " - - " (* ?vs 0.00023890) " " crlf)
                     (printout t  ?vs " - - " (* ?vs 1) " " crlf)
                     (printout t  ?vs " - - " (* ?vs 0.00028) " -" crlf)
                     (printout t  ?vs " - - " (* ?vs 0.001) " " crlf)
                     (printout t  ?vs " - - " (* ?vs 0.23890295) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule  vchs
                     (problem-response  vch) 
                     =>
                     (printout t "    -:" crlf)
                     (bind ?vch (read))
                     (assert ( vch ?vch))
                     )
(defrule itog24
                     ( vch ?vch)
                     =>
                     (printout t  ?vch " - - " (* ?vch 0.860) " " crlf)
                     (printout t  ?vch " - - " (* ?vch 3600) " " crlf)
                     (printout t  ?vch " - - " (* ?vch 3600) " -" crlf)
                     (printout t  ?vch " - - " (* ?vch 0.001) " -" crlf)
                     (printout t  ?vch " - - " (* ?vch 3.6) " " crlf)
                     (printout t  ?vch " - - " (* ?vch 860.051) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule  kvchs
                     (problem-response  kvch) 
                     =>
                     (printout t "    -:" crlf)
                     (bind ?kvch (read))
                     (assert ( kvch ?kvch))
                     )
(defrule itog25
                     ( kvch ?kvch)
                     =>
                     (printout t  ?kvch " - - " (* ?kvch 860.0506474) " " crlf)
                     (printout t  ?kvch " - - " (* ?kvch 3600000) " " crlf)
                     (printout t  ?kvch " - - " (* ?kvch 3600000) " -" crlf)
                     (printout t  ?kvch " - - " (* ?kvch 1000) " -" crlf)
                     (printout t  ?kvch " - - " (* ?kvch 3600) " " crlf)
                     (printout t  ?kvch " - - " (* ?kvch 8600050.6474) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule  kals
                     (problem-response  kal) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kal (read))
                     (assert ( kal ?kal))
                     )
(defrule itog26
                     ( kal ?kal)
                     =>
                     (printout t  ?kal "  - " (* ?kal 0.001) " " crlf)
                     (printout t  ?kal "  - " (* ?kal 4.1858) " " crlf)
                     (printout t  ?kal "  - " (* ?kal 4.1858) " -" crlf)
                     (printout t  ?kal "  - " (* ?kal 0.001163) " -" crlf)
                     (printout t  ?kal "  - " (* ?kal 0.0041858) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu7
                     (problem-response 6) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "    kg)    (, , , , ) " crlf)
                     (printout t "    mg)    (, , )" crlf)
                     (printout t "    gr)    (, , , , )" crlf)
                     (printout t "    gram)    (, , , , )" crlf)
                     (printout t "    yn)    (, , , , )" crlf)
                     (printout t "    funt)    (, , , , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule kgs
                     (problem-response kg) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kg (read))
                     (assert (kg ?kg))
                     )
(defrule itog27
                     (kg ?kg)
                     =>
                     (printout t  ?kg "  - " (* ?kg 1000000) " " crlf)
                     (printout t  ?kg "  - " (* ?kg 15432.3584) " " crlf)
                     (printout t  ?kg "  - " (* ?kg 1000) " " crlf)
                     (printout t  ?kg "  - " (* ?kg 35.274) " " crlf)
                     (printout t  ?kg "  - " (* ?kg 2.2046) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule mgs
                     (problem-response mg) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?mg (read))
                     (assert (mg ?mg))
                     )
(defrule itog28
                     (mg ?mg)
                     =>
                     (printout t  ?mg "  - " (* ?mg 0.00003527) " " crlf)
                     (printout t  ?mg "  - " (* ?mg 0.01543235) " " crlf)
                     (printout t  ?mg "  - " (* ?mg 0.001) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule grs
                     (problem-response gr) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?gr (read))
                     (assert (gr ?gr))
                     )
(defrule itog29
                     (gr ?gr)
                     =>
                     (printout t  ?gr "  - " (* ?gr 0.00228571) " " crlf)
                     (printout t  ?gr "  - " (* ?gr 0.00014285) " " crlf)
                     (printout t  ?gr "  - " (* ?gr 0.000065) " " crlf)
                     (printout t  ?gr "  - " (* ?gr 64.7989098) " " crlf)
                     (printout t  ?gr "  - " (* ?gr 0.06479890) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule grams
                     (problem-response gram) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?gram (read))
                     (assert (gram ?gram))
                     )
(defrule itog30
                     (gram ?gram)
                     =>
                     (printout t  ?gram "  - " (* ?gram 0.035274) " " crlf)
                     (printout t  ?gram "  - " (* ?gram 0.0022) " " crlf)
                     (printout t  ?gram "  - " (* ?gram 0.001) " " crlf)
                     (printout t  ?gram "  - " (* ?gram 1000) " " crlf)
                     (printout t  ?gram "  - " (* ?gram 15.43) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule yns
                     (problem-response yn) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?yn (read))
                     (assert (yn ?yn))
                     )
(defrule itog31
                     (yn ?yn)
                     =>
                     (printout t  ?yn "  - " (* ?yn 0.06249929) " " crlf)
                     (printout t  ?yn "  - " (* ?yn 0.0283) " " crlf)
                     (printout t  ?yn "  - " (* ?yn 28349.49) " " crlf)
                     (printout t  ?yn "  - " (* ?yn 437.4995) " " crlf)
                     (printout t  ?yn "  - " (* ?yn 28.35) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule funts
                     (problem-response funt) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?funt (read))
                     (assert (funt ?funt))
                     )
(defrule itog32
                     (funt ?funt)
                     =>
                     (printout t  ?funt " () - " (* ?funt 0.45) " " crlf)
                     (printout t  ?funt " () - " (* ?funt 453597.02) " " crlf)
                     (printout t  ?funt " () - " (* ?funt 7000.072) " " crlf)
                     (printout t  ?funt " () - " (* ?funt 453.5970) " " crlf)
                     (printout t  ?funt " () - " (* ?funt 16.00018) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu8
                     (problem-response 7) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "    kvat)    (, ,  ) " crlf)
                     (printout t "    vat)    (, ,  )" crlf)
                     (printout t "    mvat)    " crlf)
                     (printout t "    lsilu)     (, , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule kvats
                     (problem-response kvat) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kvat (read))
                     (assert (kvat ?kvat))
                     )
(defrule itog33
                     (kvat ?kvat)
                     =>
                     (printout t  ?kvat "  - " (* ?kvat 1000) " " crlf)
                     (printout t  ?kvat "  - " (* ?kvat 1000000) " " crlf)
                     (printout t  ?kvat "  - " (* ?kvat 1.3596) "  " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule vats
                     (problem-response vat) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?vat (read))
                     (assert (vat ?vat))
                     )
(defrule itog34
                     (vat ?vat)
                     =>
                     (printout t  ?vat "  - " (* ?vat 0.001) " " crlf)
                     (printout t  ?vat "  - " (* ?vat 1000) " " crlf)
                     (printout t  ?vat "  - " (* ?vat 0.0014) "  " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule mvats
                     (problem-response mvat) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?mvat (read))
                     (assert (mvat ?mvat))
                     )
(defrule itog35
                     (mvat ?mvat)
                     =>
                     (printout t  ?mvat "  - " (* ?mvat 0.001) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule lsilus
                     (problem-response lsilu) 
                     =>
                     (printout t "     :" crlf)
                     (bind ?lsilu (read))
                     (assert (lsilu ?lsilu))
                     )
(defrule itog36
                     (lsilu ?lsilu)
                     =>
                     (printout t  ?lsilu " . - " (* ?lsilu 0.7354988) " " crlf)
                     (printout t  ?lsilu " . - " (* ?lsilu 735.4988) " " crlf)
                     (printout t  ?lsilu " . - " (* ?lsilu 735498.8) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu9
                     (problem-response 8) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "    litr)    (., ., .,   , " crlf)
                     (printout t "              .,  .,  ,  ., , , ) " crlf)
                     (printout t "    kmil)  .  (.,  ,  ., , )" crlf)
                     (printout t "    ksan)  .  ( ,  .,  .,  ,  .," crlf)
                     (printout t "              , , , .) " crlf)
                     (printout t "    kmetr)  .  ( ,  .,  .,  ,  ., ," crlf)
                     (printout t "              , , , ., .) " crlf)
                     (printout t "    gal)     ( .,  .,  ,  ., , ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    gal2)   .  ( ,  .,  ,  ., , ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    pin)   .  ( ,   .,  ,  ., , ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    ync)     ( ,   .,  .,  ., , ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    ync2)   .  ( ,   .,  .,  , , ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    barr)    ( ,   .,  .,  .,  ., ," crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "    milil)    ( ,   .,  .,  .,  .," crlf)
                     (printout t "             , , ., .) " crlf)
                     (printout t "    santil)    ( ,   .,  .,  .,  ., " crlf)
                     (printout t "             , , ., ., .) " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule litr1
                     (problem-response litr) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?litr (read))
                     (assert (litr ?litr))
                     )
(defrule litr2
                     (litr ?litr)
                     =>
                     (printout t  ?litr "  - " (* ?litr 1000000) " ." crlf)
                     (printout t  ?litr "  - " (* ?litr 1000) " ." crlf)
                     (printout t  ?litr "  - " (* ?litr 0.001) " ." crlf)
                     (printout t  ?litr "  - " (* ?litr 0.2642) "  " crlf)
                     (printout t  ?litr "  - " (* ?litr 0.22) "  ." crlf)
                     (printout t  ?litr "  - " (* ?litr 1.76) "  ." crlf)
                     (printout t  ?litr "  - " (* ?litr 33.8140) "  " crlf)
                     (printout t  ?litr "  - " (* ?litr 35.1951) "  ." crlf)
                     (printout t  ?litr "  - " (* ?litr 0.0063) " " crlf)
                     (printout t  ?litr "  - " (* ?litr 1000) " " crlf)
                     (printout t  ?litr "  - " (* ?litr 100) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kmil1
                     (problem-response kmil) 
                     =>
                     (printout t "    ..:" crlf)
                     (bind ?kmil (read))
                     (assert (kmil ?kmil))
                     )
(defrule kmil2
                     (kmil ?kmil)
                     =>
                     (printout t  ?kmil " .. - " (* ?kmil 0.001) " ." crlf)
                     (printout t  ?kmil " .. - " (* ?kmil 0.00003381) "  " crlf)
                     (printout t  ?kmil " .. - " (* ?kmil 0.00003519) "  ." crlf)
                     (printout t  ?kmil " .. - " (* ?kmil 0.001) " " crlf)
                     (printout t  ?kmil " .. - " (* ?kmil 0.0001) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule ksan1
                     (problem-response ksan) 
                     =>
                     (printout t "    ..:" crlf)
                     (bind ?ksan (read))
                     (assert (ksan ?ksan))
                     )
(defrule ksan2
                     (ksan ?ksan)
                     =>
                     (printout t  ?ksan " .. - " (* ?ksan 1000) " ." crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.001) " ()" crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.00026417) "  " crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.00021996) "  ." crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.00176) "  ." crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.034) "  " crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.0352) "  ." crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 1) " " crlf)
                     (printout t  ?ksan " .. - " (* ?ksan 0.1) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kmetr1
                     (problem-response kmetr) 
                     =>
                     (printout t "    ..:" crlf)
                     (bind ?kmetr (read))
                     (assert (kmetr ?kmetr))
                     )
(defrule kmetr2
                     (kmetr ?kmetr)
                     =>
                     (printout t  ?kmetr " .. - " (* ?kmetr 264.17) "  " crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 219.97) "  ." crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 1759.76) "  ." crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 33814.0227) "  " crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 35195.13) "  ." crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 6.29) " " crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 1000000) " " crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 100000) " " crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 1000) " ()" crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 1000000000) " ." crlf)
                     (printout t  ?kmetr " .. - " (* ?kmetr 1000000) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule gal1
                     (problem-response gal) 
                     =>
                     (printout t "     :" crlf)
                     (bind ?gal (read))
                     (assert (gal ?gal))
                     )
(defrule gal2
                     (gal ?gal)
                     =>
                     (printout t  ?gal "   - " (* ?gal 0.83) "  ." crlf)
                     (printout t  ?gal "   - " (* ?gal 6.66) "  ." crlf)
                     (printout t  ?gal "   - " (* ?gal 128) "  " crlf)
                     (printout t  ?gal "   - " (* ?gal 133.23) "  ." crlf)
                     (printout t  ?gal "   - " (* ?gal 0.024) " " crlf)
                     (printout t  ?gal "   - " (* ?gal 3785.41) " " crlf)
                     (printout t  ?gal "   - " (* ?gal 378.541) " " crlf)
                     (printout t  ?gal "   - " (* ?gal 3.78541) " ()" crlf)
                     (printout t  ?gal "   - " (* ?gal 3785411.784) " ." crlf)
                     (printout t  ?gal "   - " (* ?gal 3785.41) " ." crlf)
                     (printout t  ?gal "   - " (* ?gal 0.0038) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule gal3
                     (problem-response gal2) 
                     =>
                     (printout t "     .:" crlf)
                     (bind ?gal2 (read))
                     (assert (gal2 ?gal2))
                     )
(defrule gal4
                     (gal2 ?gal2)
                     =>
                     (printout t  ?gal2 "  . - " (* ?gal2 1.201) "  " crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 8) "  ." crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 153.72) "  " crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 160) "  ." crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 0.029) " " crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 4546.08) " " crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 454.61) " " crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 4.55) " ()" crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 4546082.908) " ." crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 4546.08) " ." crlf)
                     (printout t  ?gal2 "  . - " (* ?gal2 0.00455) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule pin1
                     (problem-response pin) 
                     =>
                     (printout t "     .:" crlf)
                     (bind ?pin (read))
                     (assert (pin ?pin))
                     )
(defrule pin2
                     (pin ?pin)
                     =>
                     (printout t  ?pin "  . - " (* ?pin 0.125) "  ." crlf)
                     (printout t  ?pin "  . - " (* ?pin 0.15) "  " crlf)
                     (printout t  ?pin "  . - " (* ?pin 19.215) "  " crlf)
                     (printout t  ?pin "  . - " (* ?pin 20) "  ." crlf)
                     (printout t  ?pin "  . - " (* ?pin 0.0036) " " crlf)
                     (printout t  ?pin "  . - " (* ?pin 568.26) " " crlf)
                     (printout t  ?pin "  . - " (* ?pin 56.83) " " crlf)
                     (printout t  ?pin "  . - " (* ?pin 0.57) " ()" crlf)
                     (printout t  ?pin "  . - " (* ?pin 568260.3635) " ." crlf)
                     (printout t  ?pin "  . - " (* ?pin 568.26) " ." crlf)
                     (printout t  ?pin "  . - " (* ?pin 0.00057) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule ync1
                     (problem-response ync) 
                     =>
                     (printout t "     :" crlf)
                     (bind ?ync (read))
                     (assert (ync ?ync))
                     )
(defrule ync2
                     (ync ?ync)
                     =>
                     (printout t  ?ync "   - " (* ?ync 0.0065) "  ." crlf)
                     (printout t  ?ync "   - " (* ?ync 0.0078125) "  " crlf)
                     (printout t  ?ync "   - " (* ?ync 0.052) "  ." crlf)
                     (printout t  ?ync "   - " (* ?ync 1.041) "  ." crlf)
                     (printout t  ?ync "   - " (* ?ync 0.000186) " " crlf)
                     (printout t  ?ync "   - " (* ?ync 29.57) " " crlf)
                     (printout t  ?ync "   - " (* ?ync 2.957) " " crlf)
                     (printout t  ?ync "   - " (* ?ync 0.02957) " ()" crlf)
                     (printout t  ?ync "   - " (* ?ync 29573.53) " ." crlf)
                     (printout t  ?ync "   - " (* ?ync 29.573) " ." crlf)
                     (printout t  ?ync "   - " (* ?ync 0.00002957) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule ync3
                     (problem-response ync2) 
                     =>
                     (printout t "     .:" crlf)
                     (bind ?ync2 (read))
                     (assert (ync2 ?ync2))
                     )
(defrule ync4
                     (ync2 ?ync2)
                     =>
                     (printout t  ?ync2 "  . - " (* ?ync2 0.00625) "  ." crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.0075) "  " crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.05) "  ." crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.96) "  " crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.00018) " " crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 28.41) " " crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 2.841) " " crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.02841) " ()" crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 28413.02) " ." crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 28.41) " ." crlf)
                     (printout t  ?ync2 "  . - " (* ?ync2 0.00002841) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule barr1
                     (problem-response barr) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?barr (read))
                     (assert (barr ?barr))
                     )
(defrule barr2
                     (barr ?barr)
                     =>
                     (printout t  ?barr "  - " (* ?barr 34.97) "  ." crlf)
                     (printout t  ?barr "  - " (* ?barr 42) "  " crlf)
                     (printout t  ?barr "  - " (* ?barr 279.78) "  ." crlf)
                     (printout t  ?barr "  - " (* ?barr 5376) "  " crlf)
                     (printout t  ?barr "  - " (* ?barr 5595.58) "  ." crlf)
                     (printout t  ?barr "  - " (* ?barr 158987.2949) " " crlf)
                     (printout t  ?barr "  - " (* ?barr 15898.72949) " " crlf)
                     (printout t  ?barr "  - " (* ?barr 158.9872949) " ()" crlf)
                     (printout t  ?barr "  - " (* ?barr 158987294.9) " ." crlf)
                     (printout t  ?barr "  - " (* ?barr 158987.2949) " ." crlf)
                     (printout t  ?barr "  - " (* ?barr 0.158987294) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule milil1
                     (problem-response milil) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?milil (read))
                     (assert (milil ?milil))
                     )
(defrule milil2
                     (milil ?milil)
                     =>
                     (printout t  ?milil "  - " (* ?milil 0.00022) "  ." crlf)
                     (printout t  ?milil "  - " (* ?milil 0.00026) "  " crlf)
                     (printout t  ?milil "  - " (* ?milil 0.00176) "  ." crlf)
                     (printout t  ?milil "  - " (* ?milil 0.034) "  " crlf)
                     (printout t  ?milil "  - " (* ?milil 0.035) "  ." crlf)
                     (printout t  ?milil "  - " (* ?milil 0.1) " " crlf)
                     (printout t  ?milil "  - " (* ?milil 0.001) " ()" crlf)
                     (printout t  ?milil "  - " (* ?milil 1000) " ." crlf)
                     (printout t  ?milil "  - " (* ?milil 1) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule santil1
                     (problem-response santil) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?santil (read))
                     (assert (santil ?santil))
                     )
(defrule santil2
                     (santil ?santil)
                     =>
                     (printout t  ?santil " () - " (* ?santil 0.0022) "  ." crlf)
                     (printout t  ?santil " () - " (* ?santil 0.0026) "  " crlf)
                     (printout t  ?santil " () - " (* ?santil 0.0176) "  ." crlf)
                     (printout t  ?santil " () - " (* ?santil 0.34) "  " crlf)
                     (printout t  ?santil " () - " (* ?santil 0.35) "  ." crlf)
                     (printout t  ?santil " () - " (* ?santil 10) " " crlf)
                     (printout t  ?santil " () - " (* ?santil 0.000063) " " crlf)
                     (printout t  ?santil " () - " (* ?santil 0.01) " ()" crlf)
                     (printout t  ?santil " () - " (* ?santil 10000) " ." crlf)
                     (printout t  ?santil " () - " (* ?santil 10) " ." crlf)
                     (printout t  ?santil " () - " (* ?santil 0.00001) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu10
                     (problem-response 9) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                       kvm)  .  (, , , ., ., ., ., .) " crlf)
                     (printout t "                       kvkm)  .  (, , , ., ., ., ., .)" crlf)
                     (printout t "                       kvmili)  .  (, , , ., ., ., ., .)" crlf)
                     (printout t "                       akru)    (, , ., ., ., ., ., ., ., .)" crlf)
                     (printout t "                       aru)    (, , ., ., ., ., ., ., ., .)" crlf)
                     (printout t "                       gek)    (, , ., ., ., ., ., ., .) " crlf)
                     (printout t "                       kvmm)  .  (., ., .)" crlf)
                     (printout t "                       kvsm)  .  (., ., ., ., .)" crlf)
                     (printout t "                       kvdyum)  .  (., ., ., ., .)" crlf)
                     (printout t "                       kvfut)  .  (, , ., ., ., ., .)" crlf)
                     (printout t "                       kvyard)  .   (, , , ., ., ., ., .)" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule kvm1
                     (problem-response kvm) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvm (read))
                     (assert (kvm ?kvm))
                     )
(defrule kvm2
                     (kvm ?kvm)
                     =>
                     (printout t  ?kvm " . - " (* ?kvm 0.00024710) " " crlf)
                     (printout t  ?kvm " . - " (* ?kvm 0.01) " " crlf)
                     (printout t  ?kvm " . - " (* ?kvm 0.0001) " " crlf)
                     (printout t  ?kvm " . - " (* ?kvm 1000000) " ." crlf)
                     (printout t  ?kvm " . - " (* ?kvm 10000) " ." crlf)
                     (printout t  ?kvm " . - " (* ?kvm 1550.0031) " .()" crlf)
                     (printout t  ?kvm " . - " (* ?kvm 10.7639) " .()" crlf)
                     (printout t  ?kvm " . - " (* ?kvm 1.19599) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvkm1
                     (problem-response kvkm) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvkm (read))
                     (assert (kvkm ?kvkm))
                     )
(defrule kvkm2
                     (kvkm ?kvkm)
                     =>
                     (printout t  ?kvkm " . - " (* ?kvkm 247.1054) " " crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 10000) " " crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 100) " " crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 0.3861) " ." crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 1000000) " ." crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 1550003100) " .()" crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 10763910.4) " .()" crlf)
                     (printout t  ?kvkm " . - " (* ?kvkm 1195990) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvmili1
                     (problem-response kvmili) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvmili (read))
                     (assert (kvmili ?kvmili))
                     )
(defrule kvmili2
                     (kvmili ?kvmili)
                     =>
                     (printout t  ?kvmili " .() - " (* ?kvmili 640) " " crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 25899.8811) " " crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 258.998811) " " crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 2.58998811) " ." crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 2589988.11) " ." crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 4014489600) " .()" crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 27878399.96) " .()" crlf)
                     (printout t  ?kvmili " .() - " (* ?kvmili 3097599.88) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule akru1
                     (problem-response akru) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?akru (read))
                     (assert (akru ?akru))
                     )
(defrule akru2
                     (akru ?akru)
                     =>
                     (printout t  ?akru "  - " (* ?akru 40.47) " " crlf)
                     (printout t  ?akru "  - " (* ?akru 0.4047) " " crlf)
                     (printout t  ?akru "  - " (* ?akru 404685) " ." crlf)
                     (printout t  ?akru "  - " (* ?akru 40468564.22) " ." crlf)
                     (printout t  ?akru "  - " (* ?akru 0.0040) " ." crlf)
                     (printout t  ?akru "  - " (* ?akru 4046.8564) " ." crlf)
                     (printout t  ?akru "  - " (* ?akru 0.0015625) " ." crlf)
                     (printout t  ?akru "  - " (* ?akru 6272640) " .()" crlf)
                     (printout t  ?akru "  - " (* ?akru 43559.99) " .()" crlf)
                     (printout t  ?akru "  - " (* ?akru 4839.99) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule aru1
                     (problem-response aru) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?aru (read))
                     (assert (aru ?aru))
                     )
(defrule aru2
                     (aru ?aru)
                     =>
                     (printout t  ?aru "  - " (* ?aru 0.02471) " " crlf)
                     (printout t  ?aru "  - " (* ?aru 0.01) " " crlf)
                     (printout t  ?aru "  - " (* ?aru 100000000) " ." crlf)
                     (printout t  ?aru "  - " (* ?aru 1000000) " ." crlf)
                     (printout t  ?aru "  - " (* ?aru 0.0001) " ." crlf)
                     (printout t  ?aru "  - " (* ?aru 100) " ." crlf)
                     (printout t  ?aru "  - " (* ?aru 0.00003861) " ." crlf)
                     (printout t  ?aru "  - " (* ?aru 155000.31) " .()" crlf)
                     (printout t  ?aru "  - " (* ?aru 1076.39104) " .()" crlf)
                     (printout t  ?aru "  - " (* ?aru 119.599) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule gek1
                     (problem-response gek) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?gek (read))
                     (assert (gek ?gek))
                     )
(defrule gek2
                     (gek ?gek)
                     =>
                     (printout t  ?gek "  - " (* ?gek 2.4710) " " crlf)
                     (printout t  ?gek "  - " (* ?gek 100) " " crlf)
                     (printout t  ?gek "  - " (* ?gek 100000000) " ." crlf)
                     (printout t  ?gek "  - " (* ?gek 0.01) " ." crlf)
                     (printout t  ?gek "  - " (* ?gek 10000) " ." crlf)
                     (printout t  ?gek "  - " (* ?gek 0.00386102) " ." crlf)
                     (printout t  ?gek "  - " (* ?gek 15500031) " .()" crlf)
                     (printout t  ?gek "  - " (* ?gek 107639.104) " .()" crlf)
                     (printout t  ?gek "  - " (* ?gek 11959.9) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvmm1
                     (problem-response kvmm) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvmm (read))
                     (assert (kvmm ?kvmm))
                     )
(defrule kvmm2
                     (kvmm ?kvmm)
                     =>
                     (printout t  ?kvmm " . - " (* ?kvmm 0.01) " ." crlf)
                     (printout t  ?kvmm " . - " (* ?kvmm 0.001550) " .()" crlf)
                     (printout t  ?kvmm " . - " (* ?kvmm 0.00001076) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvsm1
                     (problem-response kvsm) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvsm (read))
                     (assert (kvsm ?kvsm))
                     )
(defrule kvsm2
                     (kvsm ?kvsm)
                     =>
                     (printout t  ?kvsm " . - " (* ?kvsm 100) " ." crlf)
                     (printout t  ?kvsm " . - " (* ?kvsm 0.0001) " ." crlf)
                     (printout t  ?kvsm " . - " (* ?kvsm 0.1550) " .()" crlf)
                     (printout t  ?kvsm " . - " (* ?kvsm 0.00107639) " .()" crlf)
                     (printout t  ?kvsm " . - " (* ?kvsm 0.00011959) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvdyum1
                     (problem-response kvdyum) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvdyum (read))
                     (assert (kvdyum ?kvdyum))
                     )
(defrule kvdyum2
                     (kvdyum ?kvdyum)
                     =>
                     (printout t  ?kvdyum " . - " (* ?kvdyum 645.16) " ." crlf)
                     (printout t  ?kvdyum " . - " (* ?kvdyum 6.4516) " ." crlf)
                     (printout t  ?kvdyum " . - " (* ?kvdyum 0.00064516) " ." crlf)
                     (printout t  ?kvdyum " . - " (* ?kvdyum 0.00694) " .()" crlf)
                     (printout t  ?kvdyum " . - " (* ?kvdyum 0.00077) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvfut1
                     (problem-response kvfut) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvfut (read))
                     (assert (kvfut ?kvfut))
                     )
(defrule kvfut2
                     (kvfut ?kvfut)
                     =>
                     (printout t  ?kvfut " . - " (* ?kvfut 92903.04) " ." crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 929.0304) " ." crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 0.09290304) " ." crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 0.00002295) " " crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 0.00092903) " " crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 144.0) " ." crlf)
                     (printout t  ?kvfut " . - " (* ?kvfut 0.111) " .()" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kvyard1
                     (problem-response kvyard) 
                     =>
                     (printout t "  (.):" crlf)
                     (bind ?kvyard (read))
                     (assert (kvyard ?kvyard))
                     )
(defrule kvyard2
                     (kvyard ?kvyard)
                     =>
                     (printout t  ?kvyard " . - " (* ?kvyard 836127.3924) " ." crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 8361.27) " ." crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 9.00) " .()" crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 0.8361) " ." crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 0.00008361) " " crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 0.00020661) " " crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 0.00836127) " " crlf)
                     (printout t  ?kvyard " . - " (* ?kvyard 1296.00005) " ." crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu11
                     (problem-response 10) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                       sp1)    /  (/, /, /, ) " crlf)
                     (printout t "                       sp2)    /  (/, /, /, )" crlf)
                     (printout t "                       sp3)    /  (/, , /, /)" crlf)
                     (printout t "                       sp4)    /  (, /, /, /)" crlf)
                     (printout t "                       sp5)      (/, /, /, /)" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule speed
                     (problem-response sp1) 
                     =>
                     (printout t "  (/):" crlf)
                     (bind ?sp (read))
                     (assert (sp ?sp))
                     )
(defrule speed1
                     (sp ?sp)
                     =>
                     (printout t  ?sp " / - " (* ?sp 0.6214) " ()/" crlf)
                     (printout t  ?sp " / - " (* ?sp 0.28) " /" crlf)
                     (printout t  ?sp " / - " (* ?sp 0.00017) " ()/" crlf)
                     (printout t  ?sp " / - " (* ?sp 0.54) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule speed2
                     (problem-response sp2) 
                     =>
                     (printout t "  (/):" crlf)
                     (bind ?sp2 (read))
                     (assert (sp2 ?sp2))
                     )
(defrule speed3
                     (sp2 ?sp2)
                     =>
                     (printout t  ?sp2 " ()/ - " (* ?sp2 0.4470) " /" crlf)
                     (printout t  ?sp2 " ()/ - " (* ?sp2 1.6093) " /" crlf)
                     (printout t  ?sp2 " ()/ - " (* ?sp2 0.00028) " ()/" crlf)
                     (printout t  ?sp2 " ()/ - " (* ?sp2 0.87) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule speed4
                     (problem-response sp3) 
                     =>
                     (printout t "  (/):" crlf)
                     (bind ?sp3 (read))
                     (assert (sp3 ?sp3))
                     )
(defrule speed5
                     (sp3 ?sp3)
                     =>
                     (printout t  ?sp3 " / - " (* ?sp3 0.00062) " ()/" crlf)
                     (printout t  ?sp3 " / - " (* ?sp3 1.9438) " " crlf)
                     (printout t  ?sp3 " / - " (* ?sp3 3.6) " /" crlf)
                     (printout t  ?sp3 " / - " (* ?sp3 2.24) " ()/" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule speed6
                     (problem-response sp4) 
                     =>
                     (printout t "  (/):" crlf)
                     (bind ?sp4 (read))
                     (assert (sp4 ?sp4))
                     )
(defrule speed7
                     (sp4 ?sp4)
                     =>
                     (printout t  ?sp4 " ()/ - " (* ?sp4 3128.31) " " crlf)
                     (printout t  ?sp4 " ()/ - " (* ?sp4 5793.64) " /" crlf)
                     (printout t  ?sp4 " ()/ - " (* ?sp4 3600.000044) " ()/" crlf)
                     (printout t  ?sp4 " ()/ - " (* ?sp4 1609.344) " /" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule speed8
                     (problem-response sp5) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?sp5 (read))
                     (assert (sp5 ?sp5))
                     )
(defrule speed9
                     (sp5 ?sp5)
                     =>
                     (printout t  ?sp5 "  - " (* ?sp5 1.8520) " /" crlf)
                     (printout t  ?sp5 "  - " (* ?sp5 1.15) " ()/" crlf)
                     (printout t  ?sp5 "  - " (* ?sp5 0.514) " /" crlf)
                     (printout t  ?sp5 "  - " (* ?sp5 0.00032) " ()/" crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu12
                     (problem-response 11) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                       cel)       () " crlf)
                     (printout t "                       far)       ()" crlf)
                     (printout t "                       kel)       ()" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule cels
                     (problem-response cel) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?cel (read))
                     (assert (cel ?cel))
                     )
(defrule cels2
                     (cel ?cel)
                     =>
                     (printout t  ?cel "  - " (* ?cel 33.8) " " crlf)
                     (printout t  ?cel "  - " (* ?cel 274.15) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule fars
                     (problem-response far) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?far (read))
                     (assert (far ?far))
                     )
(defrule fars2
                     (far ?far)
                     =>
                     (printout t  ?far "  - " (* ?far 255.93) " " crlf)
                     (printout t  ?far "  - " (* ?far -17.22) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kels
                     (problem-response kel) 
                     =>
                     (printout t "    :" crlf)
                     (bind ?kel (read))
                     (assert (kel ?kel))
                     )
(defrule kels2
                     (kel ?kel)
                     =>
                     (printout t  ?kel "  - " (* ?kel -272.15) " " crlf)
                     (printout t  ?kel "  - " (* ?kel -457.87) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule main-menu13
                     (problem-response 12) 
                     =>
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                       byte)     " crlf)
                     (printout t "                       kb)     ()" crlf)
                     (printout t "                       mb)     (, )" crlf)
                     (printout t "                       gb)     (, , )" crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response)) 
                     )  
(defrule bytes
                     (problem-response byte) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?byte (read))
                     (assert (byte ?byte))
                     )
(defrule bytes2
                     (byte ?byte)
                     =>
                     (printout t  ?byte "  - " (* ?byte 8) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule kbs
                     (problem-response kb) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?kb (read))
                     (assert (kb ?kb))
                     )
(defrule kbs2
                     (kb ?kb)
                     =>
                     (printout t  ?kb "  - " (* ?kb 1024) " " crlf)
                     (printout t  ?kb "  - " (* ?kb 1024 8) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule mbs
                     (problem-response mb) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?mb (read))
                     (assert (mb ?mb))
                     )
(defrule mbs2
                     (mb ?mb)
                     =>
                     (printout t  ?mb "  - " (* ?mb 1024) " " crlf)
                     (printout t  ?mb "  - " (* ?mb (** 1024 2)) " " crlf)
                     (printout t  ?mb "  - " (* ?mb (** 1024 2) 8) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule gbs
                     (problem-response gb) 
                     =>
                     (printout t "  :" crlf)
                     (bind ?gb (read))
                     (assert (gb ?gb))
                     )
(defrule gbs2
                     (gb ?gb)
                     =>
                     (printout t  ?gb "  - " (* ?gb 1024) " " crlf)
                     (printout t  ?gb "  - " (* ?gb (** 1024 2)) " " crlf)
                     (printout t  ?gb "  - " (* ?gb (** 1024 3)) " " crlf)
                     (printout t  ?gb "  - " (* ?gb (** 1024 3) 8) " " crlf)
 (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule user-exit
                     (troubleshoot-mode)
                     (problem-response 13) 
                      =>
                     (printout t " !" crlf)
                     (halt))
                     


                   
                    
                                

                     
                     


                   
                   