(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))) ?answer)

(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))

(deffacts init
           (troubleshoot-mode)
           (menu-level))

(defrule main-menu
                     (declare (salience 500))
                     (troubleshoot-mode) 
                     ?ml <- (menu-level) 
                     =>
                     (retract ?ml)
                     (printout t "                                    MINI CALCULATOR!" crlf)
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1)  " crlf)
                     (printout t "                                2)   " crlf) 
                     (printout t "                                3)  " crlf) 
                     (printout t "                                4)   " crlf)
                     (printout t "                                5)  " crlf) 
                     (printout t "                                6)   " crlf) 
                     (printout t "                                7)   " crlf) 
                     (printout t "                                8)    float" crlf) 
                     (printout t "                                9)    integer" crlf) 
                     (printout t "                                10)    ( )" crlf) 
                     (printout t "                                11)    p" crlf)
                     (printout t "                                12)   " crlf) 
                     (printout t "                                13)   " crlf) 
                     (printout t "                                14)  " crlf)
                     (printout t "                                15)  " crlf) 
                     (printout t "                                16)   " crlf) 
                     (printout t "                                17)  " crlf) 
                     (printout t "                                18)    " crlf) 
                     (printout t "                                19)  sin, cos, tan, cot" crlf)
                     (printout t "                                20)  (a+b)^n" crlf)
                     (printout t "                                21)  (a-b)^n" crlf)
                     (printout t "                                22)  (a*b)^n" crlf)
                     (printout t "                                23)  (a/b)^n" crlf)
                     (printout t "                                24)   " crlf)
                     (printout t "      " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response))
                     )
(defrule slogenie
                     (problem-response 1) 
                      =>
                     (printout t "  " crlf)
                     (bind ?x (read))
                     (assert (x ?x))
                     (printout t "  " crlf)
                     (bind ?y (read))
                     (assert (y ?y))
                   )

(defrule slogenie2
                     (x ?x)
                     (y ?y) 
                      =>
                     (printout t "  : ("?x" + "?y")" "= " (+ ?x ?y) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule vuchitanie
                     (problem-response 2) 
                      =>
                     (printout t "  " crlf)
                     (bind ?a (read))
                     (assert (a ?a))
                     (printout t "  " crlf)
                     (bind ?b (read))
                     (assert (b ?b)))
(defrule vuchitanie2
                     (a ?a)
                     (b ?b) 
                      =>
                     (printout t "  : ("?a" - "?b")" "= " (- ?a ?b) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule ymnogenie
                     (problem-response 3) 
                      =>
                     (printout t "  " crlf)
                     (bind ?c (read))
                     (assert (c ?c))
                     (printout t "  " crlf)
                     (bind ?d (read))
                     (assert (d ?d)))
(defrule ymnogenie2
                     (c ?c)
                     (d ?d) 
                      =>
                     (printout t "  : ("?c" * "?d")" "= " (* ?c ?d) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule delenie
                     (problem-response 4) 
                      =>
                     (printout t "  " crlf)
                     (bind ?e (read))
                     (assert (e ?e))
                     (printout t "  " crlf)
                     (bind ?f (read))
                     (assert (f ?f)))
(defrule delenie2
                     (e ?e)
                     (f ?f) 
                      =>
                     (printout t "  : ("?e" / "?f")" "= " (/ ?e ?f) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule celochislennoedelenie
                     (problem-response 5) 
                      =>
                     (printout t "  " crlf)
                     (bind ?e1 (read))
                     (assert (e1 ?e1))
                     (printout t "  " crlf)
                     (bind ?f1 (read))
                     (assert (f1 ?f1)))
(defrule celochislennoedelenie2
                     (e1 ?e1)
                     (f1 ?f1) 
                      =>
                     (printout t "  = " (div ?e1 ?f1) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule max
                     (problem-response 6) 
                      =>
                     (printout t "  " crlf)
                     (bind ?a1 (read))
                     (assert (a1 ?a1))
                     (printout t "  " crlf)
                     (bind ?b1 (read))
                     (assert (b1 ?b1)))
(defrule max2
                     (a1 ?a1)
                     (b1 ?b1) 
                      =>
                     (printout t "  " (max ?a1 ?b1) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule min
                     (problem-response 7) 
                      =>
                     (printout t "  " crlf)
                     (bind ?c1 (read))
                     (assert (c1 ?c1))
                     (printout t "  " crlf)
                     (bind ?d1 (read))
                     (assert (d1 ?d1)))
(defrule min2
                     (c1 ?c1)
                     (d1 ?d1) 
                      =>
                     (printout t "  " (min ?c1 ?d1) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule float
                     (problem-response 8) 
                      =>
                     (printout t " " crlf)
                     (bind ?flo (read))
                     (assert (flo ?flo)))
(defrule float2
                     (flo ?flo)
                     =>
                     (printout t (float ?flo) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule integer
                     (problem-response 9) 
                      =>
                     (printout t " " crlf)
                     (bind ?int (read))
                     (assert (int ?int)))
(defrule integer2
                     (int ?int)
                     =>
                     (printout t (integer ?int) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule modul
                     (problem-response 10) 
                      =>
                     (printout t " " crlf)
                     (bind ?mod (read))
                     (assert (mod ?mod)))
(defrule modul2
                     (mod ?mod)
                     =>
                     (printout t (abs ?mod) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule pi
                     (problem-response 11) 
                      =>
                     (printout t " pi   " (pi) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule koren
                     (problem-response 12) 
                      =>
                     (printout t " " crlf)
                     (bind ?kor (read))
                     (assert (kor ?kor)))
(defrule koren2
                     (kor ?kor)
                     =>
                     (printout t (sqrt ?kor) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule step
                     (problem-response 13) 
                      =>
                     (printout t " " crlf)
                     (bind ?chislo (read))
                     (assert (chislo ?chislo))
                     (printout t "  " crlf)
                     (bind ?stepen (read))
                     (assert (stepen ?stepen)))
(defrule step2
                     (chislo ?chislo)
                     (stepen ?stepen) 
                      =>
                     (printout t ?chislo "   " ?stepen " = " (** ?chislo ?stepen) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule exp
                     (problem-response 14) 
                      =>
                     (printout t " " crlf)
                     (bind ?ex (read))
                     (assert (ex ?ex)))
(defrule exp2
                     (ex ?ex)
                     =>
                     (printout t (exp ?ex) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule log
                     (problem-response 15) 
                      =>
                     (printout t " " crlf)
                     (bind ?lg (read))
                     (assert (lg ?lg)))
(defrule log2
                     (lg ?lg)
                     =>
                     (printout t "(log " ?lg ") = " (log ?lg) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))
    
(defrule log10
                     (problem-response 16) 
                      =>
                     (printout t " " crlf)
                     (bind ?lg2 (read))
                     (assert (lg2 ?lg2)))
(defrule log102
                     (lg2 ?lg2)
                     =>
                     (printout t "(log10 " ?lg2 ") = " (log10 ?lg2) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))
  
(defrule round
                     (problem-response 17) 
                      =>
                     (printout t " " crlf)
                     (bind ?rnd (read))
                     (assert (rnd ?rnd)))
(defrule round2
                     (rnd ?rnd)
                     =>
                     (printout t (round ?rnd) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))
      
(defrule mod
                     (problem-response 18) 
                      =>
                     (printout t "  " crlf)
                     (bind ?md (read))
                     (assert (md ?md))
                     (printout t "  " crlf)
                     (bind ?md2 (read))
                     (assert (md2 ?md2)))
(defrule mod2
                     (md ?md)
                     (md2 ?md2) 
                      =>
                     (printout t "   " (mod ?md ?md2) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule trigon
                     (problem-response 19) 
                      =>
                     (printout t " " crlf)
                     (bind ?n (read))
                     (assert (n ?n)))
(defrule trigon2
                     (n ?n)
                     =>
                     (printout t " : (sin " ?n ") = "  (sin (deg-rad ?n)) crlf)
                     (printout t " : (sin " ?n ") = "  (sin ?n) crlf)
                     (printout t "      " crlf)
                     (printout t " : (cos " ?n ") = "  (cos (deg-rad ?n)) crlf)
                     (printout t " : (cos " ?n ") = "  (cos ?n) crlf)
                     (printout t "      " crlf)
                     (printout t " : (tan " ?n ") = "  (tan (deg-rad ?n)) crlf)
                     (printout t " : (tan " ?n ") = "  (tan ?n) crlf)
                     (printout t "      " crlf)
                     (printout t " : (cot " ?n ") = "  (cot (deg-rad ?n)) crlf)
                     (printout t " : (cot " ?n ") = "  (cot ?n) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule slogenie3
                     (problem-response 20) 
                      =>
                     (printout t "  " crlf)
                     (bind ?sumkv (read))
                     (assert (sumkv ?sumkv))
                     (printout t "  " crlf)
                     (bind ?sumkv2 (read))
                     (assert (sumkv2 ?sumkv2))
                     (printout t " " crlf)
                     (bind ?sumkv3 (read))
                     (assert (sumkv3 ?sumkv3))
                   )

(defrule slogenie4
                     (sumkv ?sumkv)
                     (sumkv2 ?sumkv2)
                     (sumkv3 ?sumkv3)
                      =>
                     (printout t ": ("?sumkv" + "?sumkv2")^"?sumkv3 "   = " (** (+ ?sumkv ?sumkv2) ?sumkv3) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule vuchitanie3
                     (problem-response 21) 
                      =>
                     (printout t "  " crlf)
                     (bind ?vuchkv (read))
                     (assert (vuchkv ?vuchkv))
                     (printout t "  " crlf)
                     (bind ?vuchkv2 (read))
                     (assert (vuchkv2 ?vuchkv2))
                     (printout t " " crlf)
                     (bind ?vuchkv3 (read))
                     (assert (vuchkv3 ?vuchkv3))
                   )

(defrule vuchitanie4
                     (vuchkv ?vuchkv)
                     (vuchkv2 ?vuchkv2)
                     (vuchkv3 ?vuchkv3)
                      =>
                     (printout t ": ("?vuchkv" - "?vuchkv2")^"?vuchkv3 "   = " (** (- ?vuchkv ?vuchkv2) ?vuchkv3) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))
                
(defrule ymnogenie3
                     (problem-response 22) 
                      =>
                     (printout t "  " crlf)
                     (bind ?ymnogkv (read))
                     (assert (ymnogkv ?ymnogkv))
                     (printout t "  " crlf)
                     (bind ?ymnogkv2 (read))
                     (assert (ymnogkv2 ?ymnogkv2))
                     (printout t " " crlf)
                     (bind ?ymnogkv3 (read))
                     (assert (ymnogkv3 ?ymnogkv3))
                   )

(defrule ymnogenie4
                     (ymnogkv ?ymnogkv)
                     (ymnogkv2 ?ymnogkv2)
                     (ymnogkv3 ?ymnogkv3)
                      =>
                     (printout t ": ("?ymnogkv" * "?ymnogkv2")^"?ymnogkv3 "   = " (** (* ?ymnogkv ?ymnogkv2) ?ymnogkv3) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule delenie3
                     (problem-response 23) 
                      =>
                     (printout t "  " crlf)
                     (bind ?delkv (read))
                     (assert (delkv ?delkv))
                     (printout t "  " crlf)
                     (bind ?delkv2 (read))
                     (assert (delkv2 ?delkv2))
                     (printout t " " crlf)
                     (bind ?delkv3 (read))
                     (assert (delkv3 ?delkv3))
                   )

(defrule delenie4
                     (delkv ?delkv)
                     (delkv2 ?delkv2)
                     (delkv3 ?delkv3)
                      =>
                     (printout t ": ("?delkv" / "?delkv2")^"?delkv3 "   = " (** (/ ?delkv ?delkv2) ?delkv3) crlf)
(if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

(defrule user-exit
                     (troubleshoot-mode)
                     (problem-response 24) 
                      =>
                     (printout t " !" crlf)
                     (halt))
