(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))) ?answer)

(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))

(deffacts init
           (troubleshoot-mode)
           (menu-level))

(defrule main-menu
                     (declare (salience 500))
                     (troubleshoot-mode) 
                     ?ml <- (menu-level) 
                     =>
                     (retract ?ml)
                     (printout t "  " crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1)  " crlf)
                     (printout t "                                2)   " crlf) 
                     (printout t "                                                                    " crlf)
                     (printout t " : " crlf) 
                     (bind ?response (read))
                     (assert (problem-response ?response))
                     )
(defrule user-exit
                     (troubleshoot-mode)
                     (problem-response 2) 
                      =>
                     (printout t " !" crlf)
                     (halt))
(defglobal ?*x* = 8)
(defglobal ?*y* = 0.5)

(defrule dannue
                     (problem-response 1) 
                      =>
                     (printout t "  :" crlf)
                     (bind ?x (read))
                     (assert (x ?x))
                     (printout t "  :" crlf)
                     (bind ?y (read))
                     (assert (y ?y))
                     (printout t "  :" crlf)
                     (bind ?z (read))
                     (assert (z ?z))
                     (printout t " :" crlf)
                     (bind ?m (read))
                     (assert (m ?m))
                     (printout t " :" crlf)
                     (bind ?g (read))
                     (assert (g ?g))
                     (printout t "  :" crlf)
                     (bind ?t (read))
                     (assert (t ?t))
                     (printout t " :" crlf)
                     (bind ?okl (read))
                     (assert (okl ?okl))
                     (printout t "    :" crlf)
                     (bind ?day (read))
                     (assert (day ?day))
                     (printout t "   -   ,   -  :" crlf)
                     (bind ?prem (read))
                     (assert (prem ?prem))
                     (printout t "   ( /  670 ) -   - 175, 
                       ( /  670 ) -  :" crlf)
                     (bind ?l (read))
                     (assert (l ?l))
                     (printout t "  ( /   -  1(%), 
                        -  2(%)):" crlf)
                     (bind ?pens (read))
                     (assert (pens ?pens))
                     (printout t " ( /   -  0.5(%), 
                        -  1(%)):" crlf)
                     (bind ?s (read))
                     (assert (s ?s)) 
                     )

(defrule raschet
                     (x ?x)
                     (y ?y) 
                     (z ?z)
                     (m ?m)
                     (g ?g)
                     (t ?t)
                     (okl ?okl)
                     (day ?day)
                     (prem ?prem)
                     (l ?l)
                     (pens ?pens)
                     (s ?s)
                      =>
                     (open "zarplata.txt" zarplata "a")
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t " |                              | "crlf)   
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t "     "  ?m " " ?g "  "crlf)
                     (printout zarplata t "   : " ?t            "     "crlf)
                     (printout zarplata t "  " ?x " " ?y " " ?z               "     "crlf)
                     (printout zarplata t "  : "  ?okl "                    "crlf)
                     (printout zarplata t "   : "  ?day "            "crlf)
                     (printout zarplata t "  : " ?*x* "                         "crlf)
                     (printout zarplata t "    : " (* ?day ?*x*) "  "crlf)
                     (printout zarplata t "  : "  ?prem  "                 "crlf)
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t "   : " (+ ?okl ?prem) " "crlf)
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t " |                               | "crlf) 
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t "    "  ?pens "%: " (/ (* ?pens (+ ?okl ?prem)) 100) "  " crlf)
                     (printout zarplata t "    " ?*y* "%: " (/ (* ?*y* (+ ?okl ?prem)) 100) "  " crlf)
                     (printout zarplata t "   "  ?s "%: " (/ (* ?s (+ ?okl ?prem)) 100) "  " crlf)
                     (printout zarplata t "   : "  (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) "  " crlf)
                     (printout zarplata t "  : " ?l "  " crlf)
                     (printout zarplata t "  : "  (+ (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) (/ (* ?s (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?pens (+ ?okl ?prem)) 100)) "  " crlf)
                     (printout zarplata t " ------------------------------------------"crlf)
                     (printout zarplata t "     "  ?m " " ?g " : "  (- (+ ?okl ?prem) (+ (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) (/ (* ?s (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?pens (+ ?okl ?prem)) 100))) "  " crlf)
                     (printout zarplata t " ------------------------------------------"crlf)
                     (close zarplata)
                
                     (printout t "   "crlf)
                     (printout t " ------------------------------------------"crlf)
                     (printout t " |                              | "crlf)    
                     (printout t " ------------------------------------------"crlf)
                     (printout t "     "  ?m " " ?g "  "crlf)
                     (printout t "   : " ?t            "     "crlf)
                     (printout t "  " ?x " " ?y " " ?z               "     "crlf)
                     (printout t "  : "  ?okl "                    "crlf)
                     (printout t "   : "  ?day "            "crlf)
                     (printout t "  : " ?*x* "                         "crlf)
                     (printout t "    : " (* ?day ?*x*) "  "crlf)
                     (printout t "  : "  ?prem  "                 "crlf)
                     (printout t " ------------------------------------------"crlf)
                     (printout t "   : " (+ ?okl ?prem) " "crlf)
                     (printout t " ------------------------------------------"crlf)
                     (printout t "   "crlf)
                     (printout t " ------------------------------------------"crlf)
                     (printout t " |                               | "crlf) 
                     (printout t " ------------------------------------------"crlf)
                     (printout t "    "  ?pens "%: " (/ (* ?pens (+ ?okl ?prem)) 100) "  " crlf)
                     (printout t "    " ?*y* "%: " (/ (* ?*y* (+ ?okl ?prem)) 100) "  " crlf)
                     (printout t "   "  ?s "%: " (/ (* ?s (+ ?okl ?prem)) 100) "  " crlf)
                     (printout t "   : "  (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) "  " crlf)
                     (printout t "  : " ?l "  " crlf)
                     (printout t "  : "  (+ (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) (/ (* ?s (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?pens (+ ?okl ?prem)) 100)) "  " crlf)
                     (printout t " ------------------------------------------"crlf)
                     (printout t "     "  ?m " " ?g " : "  (- (+ ?okl ?prem) (+ (/ (* (- (+ ?okl ?prem) (/ (* ?pens (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?s (+ ?okl ?prem)) 100) ?l) 13) 100) (/ (* ?s (+ ?okl ?prem)) 100) (/ (* ?*y* (+ ?okl ?prem)) 100) (/ (* ?pens (+ ?okl ?prem)) 100))) "  " crlf)
                     (printout t " ------------------------------------------"crlf)
                     (if (yes-or-no-p "  (yes/no)? ")
                      then
                     (reset)
                     (run)
                     else
                     (printout t " !     !" crlf) 
                     (halt)))

