(deffunction ask-question (?question $?allowed-values) (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
                then
               (bind ?answer (lowcase ?answer)))
               (while (not (member ?answer ?allowed-values)) do
               (printout t ?question) (bind ?answer (read))
               (if (lexemep ?answer)
               then
              (bind ?answer (lowcase ?answer)))) ?answer)
(deffunction yes-or-no-p (?question)
              (bind ?response (ask-question ?question yes no y n))
              (if (or (eq ?response yes) (eq ?response y))
              then
              TRUE
              else
              FALSE))
(defrule begin ""
              (not (patient is in?)) (not (help ?))
              =>
             (if (yes-or-no-p "   ? (yes/no)? ")                         
             then
             (if (yes-or-no-p "   ? (yes/no)? ")
             then
             (assert (patient is in consciousness))   
             else
             (assert (patient is in bad condition)) (assert (patient is in a uncertain condition)))
             else
             (assert (patient is in a normal condition))))
(defrule  test ""
             (patient is in a uncertain condition)
             (not (initial phenomena ?))
             (not (help ?))
             =>
             (if ( yes-or-no-p "   ,  , 
                ,  ,  ? (yes/no)? ")    
             then 
             (assert (initial phenomena sunstroke))
             (assert (initial phenomena thermal impact))
             else
             (assert (initial phenomena electrotrauma))
             (assert (initial phenomena poisoning))))
(defrule test1 ""
             (patient is in a uncertain condition)
             (initial phenomena thermal impact)
             (not (help ?))
             =>
             (if ( yes-or-no-p "   ,   , 
               (),   . 
               ? (yes/no)? ")
             then
             (assert (help "   .  : 
                  .     , 
                  ,    . 
                   ,     ."))))                        
(defrule test2 ""
            (patient is in a uncertain condition)
            (initial phenomena sunstroke)
            (not (help ?))
             =>
             (if ( yes-or-no-p "   , ,  ,  , 
               .    ,  ? (yes/no)? ")
              then
             (assert (help "    .  : 
                ,     , 
                   ,    . 
                    ,     "))))
(defrule test3 ""
             (patient is in a uncertain condition)
             (initial phenomena poisoning)
             (not (help ?))
             =>
             (if ( yes-or-no-p "     ,   ,  . 
                   ,  , 
               ,    ? (yes/no)? ")
                then
             (assert (help "  -  .  :  
               ,   ,    ."))))
(defrule test4 ""
             (patient is in a uncertain condition)
             (initial phenomena electrotrauma)
             (not (help ?))
             =>
            (if ( yes-or-no-p "     ',    ? (yes/no)? ")
            then
           (assert (help " :      ."))))
(defrule test5 ""
           (patient is in a uncertain condition)
           (not (patient is in ?))
           (not (help ?))           
           =>
          (if (yes-or-no-p "      , 
           , ? (yes/no)? ")
           then
           (assert (patient is in faint))
           else
           (assert (patient is in not faint))))
(defrule test6 ""
            (patient is in a uncertain condition)
            (patient is in faint)
            (not (help ?))
             =>
            (if ( yes-or-no-p "  ,  .  ,
              ,  ,  ,  ? (yes/no)? ")    
             then 
             (assert (help "  :        "))
             else 
             (if ( yes-or-no-p "     ? (yes/no)? ") 
             then
             (assert (help "  :   ,  ,   . 
                  .")))  
             (assert (patient is in not faint))))
(defrule test7 ""
            (patient is in a uncertain condition)                
            (not (help ?))           
             =>
            (if (yes-or-no-p "         (), 
                 ,    .   ? (yes/no)? ")
            then
            (assert (help " -  .  :  , 
             ',   ."))
            else
            (assert (help " -   .  :     , 
             '. "))))
(defrule test8 ""
            (patient is in bad condition)
            (not (traumas of a stomach | traumas of a skull))
            (not (help ?))
            =>
            (if (yes-or-no-p "   ?  (yes/no)? ")
            then
            (assert (traumas of a stomach))
            else
            (assert (traumas of a skull))))
(defrule test9 ""
            (or (and (patient is in bad condition) (patient is in not faint)) (traumas of a stomach))
            (not (help ?))
             =>
            (bind ?response (ask-question "    
            ( 1    /2    /3    ) ?" 1 2 3 ))
            (if (eq ?response 2) 
            then
            (assert (help "  :    .  .
  ,   .  .   . "))
            else
            (if (eq ?response 3)
            then
            (assert (help "  .")))))
(defrule test10 ""
            (patient is in bad condition)
            (patient is in not faint)
            (traumas of a stomach) 
            (not (help ?))
              =>
             (if (yes-or-no-p "        , , , 
             ,  ,    ? (yes/no)? ")
             then
             (assert (help "   , ' ,  .
               . "))))
(defrule test11 ""
            (patient is in bad condition)
            (traumas of a skull)
            (not (help ?))
              =>
            (if (yes-or-no-p "       ? (yes/no)? ")
            then
            (assert (help "  :    , ' , 
             ,  .   ."))
            else
            (assert (crises of the patient))))
(defrule test12 ""
            (or (and (patient is in bad condition) (patient is in not faint)) (crises of the patient))
            (not (help ?))
            =>
           (bind ?response (ask-question "  ? (1     / 
           2   / 3  ) ?" 1 2 3))
           (if (eq ?response 2)
           then
           (assert (help " :  ,   .  ."))
            else 
           (if (eq ?response 3)
            then
           (assert (help "  .")))))
(defrule test13 ""
            (patient is in bad condition)
            (not (help ?))
             =>
            (if (yes-or-no-p "   ,      ? (yes/no)? ")
             then
            (assert (help ", ,  .  :    , 
              ,    ."))))
(defrule test14 ""
             (patient is in bad condition)
             (not (help ?))
              =>
             (if (yes-or-no-p "     :    ,   ,
  ,  ,    ? (yes/no)? ")
             then
             (assert (help "  ,   ."))))                 
(defrule test15 ""
            (declare (salience 10))
            (patient is in a normal condition)
             =>
            (assert (pomosh "    䳺."))
            (assert (patient is in faint)))
(defrule test16 "" 
            (declare (salience 10))
            (patient is in consciousness)
             =>
            (assert (patient is in faint))
            (assert (help "  .     !")))    
(defrule print-help ""
            (declare (salience 10))
            (help ?item)
             =>
            (printout t crlf crlf)
            (printout t "  :")
            (printout t crlf crlf)
            (format t " %s%n%n%n" ?item))
(defrule no-helps ""
            (declare (salience -10))
            (not (help ?))
            =>
           (assert (help "    .         !")))
(deffacts init
           (troubleshoot-mode medic)
           (menu-level medic main))
(defrule main-menu
                     (declare (salience 10))
                     (troubleshoot-mode medic) ?ml <- (menu-level medic main) =>
                     (retract ?ml)
                     (printout t crlf crlf )
                     (printout t "                                   " crlf)
                     (printout t "                                                                   " crlf)
                     (printout t "                                1)    " crlf)
                     (printout t "                                2)   " crlf) 
                     (printout t "                                                                    " crlf)
                     (printout t " : " crlf) (bind ?response (read))
                     (assert (problem-response medic ?response))
                     (printout t crlf crlf ))
(defrule user-exit
                     (troubleshoot-mode medic)
                     (problem-response medic 2) 
                      =>
                     (printout t " !" crlf)
                     (halt))
(defrule begin-start
                      (troubleshoot-mode medic) ?pr <- (problem-response medic 1) 
                      =>
                      (retract ?pr)
                      (assert (defrule begin)))
(defrule system-banner ""
                (declare (salience 10))
                =>
                 (printout t crlf crlf)
                 (printout t "                                  ***************************************" crlf)
                 (printout t "                                  *   The Medic Diagnosis Expert System *" crlf)
                 (printout t "                                  ***************************************" crlf)
                 (printout t "                                                                                                                " crlf)
                 (printout t "           The Medc Dagnoss Expert System  -   ,     " crlf) 
                 (printout t "                  ,    ." crlf)
                 (printout t "                    ͳ       " crlf) 
                (printout t crlf crlf))

